 program CURdemo;

 {$g+,i-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,x+,i-,n-}

(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 uses MegaGraf,Keyboard,GfxMouse,AddMouse,MemPlus,i80386,Fonts;

 var c:       Pointer;
     White:   LongInt;
     MX,MY:   Word;
     LX,LY:   Word;
     MsX,MsY: Word;
     Color:   LongInt;
     m:       Char;
     gr:      Byte;
     pal:     Pointer;

 procedure FillPattern;
 var value,i: LongInt;
 begin
  MX:=mgXRes-1;
  MY:=mgYRes div 2;
  ClearVideoMem;
  if mgColorMode>GrSVGA256 then begin
   for i:=0 to MX do begin
    DrawLine(MX shr 1,MY shr 1,i,0,RGBColor((i*mgRedMask) div MX,0,0));
    DrawLine(MX shr 1,MY shr 1,i,MY,RGBColor(0,(i*mgGreenMask) div MX,0));
   end;
   for i:=0 to MY do begin
    value:=Word((i*mgBlueMask) div MY);
    DrawLine(MX shr 1,MY shr 1,0,i,RGBColor(value,0,mgBlueMask-value));
    DrawLine(MX shr 1,MY shr 1,MX,i,RGBColor(0,mgGreenMask-value,value));
   end;
   White:=RGBColor($FF,$FF,$FF);
  end else begin
   i:=0;
   repeat
    DrawLine(MX shr 1,MY shr 1,i,0,i mod 255);
    DrawLine(MX shr 1,MY shr 1,i,MY,(i+1) mod 255);
    inc(i);
   until (i>MX);
   i:=0;
   repeat
    DrawLine(MX shr 1,MY shr 1,0,i,(i+2) mod 255);
    DrawLine(MX shr 1,MY shr 1,MX,i,(i+3) mod 255);
    inc(i);
   until (i>MY);
   White:=VGAWhite;
  end;
  DrawRectangle(0,0,MX,MY,White);
  DrawRectangle(0,MY,MX,MY*2-1,White);
  PutStringXY(280,360,'DRAWING AREA',White);
 end;

 begin
  if not InitVBE then begin
   Writeln(' VESA VBE 1.2+ is not found...');
   exit;
  end;
  SetTextMode;
  repeat
  Writeln;
  Writeln(' Coose video mode:');
  Writeln(' -----------------');
  Writeln(' 1. SVGA 640x480x256');
  Writeln(' 2. SVGA 640x480x32K');
  Writeln(' 3. SVGA 640x480x64K');
  Writeln(' 4. SVGA 640x480x16M');
  Writeln(' 5. SVGA 640x480x16M+A');
  Writeln;
  Writeln(' 0. Quit');
  Writeln;
  repeat
   m:=xReadKey;
  until (m>='0') and (m<'6');
  if m='0' then halt(0);
  case m of
   '1': gr:=grSVGA256;
   '2': gr:=grSVGA32K;
   '3': gr:=grSVGA64K;
   '4': gr:=grSVGA16M;
   '5': gr:=grSVGA4G;
  end;
  if SetSVGAMode(640,480,gr) then begin
   SetChars(@RUS8x16,1,16,0,1);
   case m of
    '1': begin
          c:=LoadFile('mcur256.cur');
          pal:=LoadFile('mcur256.pal');
          SetVGAPalette(pal,0,8);
         end;
    '2': c:=LoadFile('mcur32K.cur');
    '3': c:=LoadFile('mcur64K.cur');
    '4': c:=LoadFile('mcur16M.cur');
    '5': c:=LoadFile('mcur16MA.cur');
   end;
   if (c=nil) or ((pal=nil) and (m='1')) then begin
    SetTextMode;
    Writeln;
    Writeln(' Can`t load file...');
    halt(0);
   end;
   FillPattern;
   MouseXShr:=2; MouseYShr:=2;
   SetGfxCursor(c);
   if not EnableGfxMouse then begin SetTextMode; exit; end;
   GfxMouseFreq:=0;
   AnimationFreq:=0;
   ResetMouseOnStart:=true;
   SetCorrelationXY(1,1);
   LX:=MX div 2;
   LY:=MY + MY div 2;
   Color:=White;
   repeat
    MsX:=GfxMouseX;
    MsY:=GfxMouseY;
    if not LeftButtonPressed then LY:=$FFFF;
    if (LeftButtonPressed) then begin
     if LY=$FFFF then begin
      LX:=GfxMouseX;
      LY:=GfxMouseY;
     end else begin
      if (MsY>MY) and (LY>MY) then begin
       HideGfxMouse;
       DrawLine(LX,LY,MsX,MsY,Color);
       LX:=MsX; LY:=MsY;
       ShowGfxMouse;
      end;
     end;
     if (MsY<MY) then begin
      HideGfxMouse;
      Color:=GetPoint(GfxMouseX,GfxMouseY);
      ShowGfxMouse;
     end;
    end;
    Retrace;
   until (xKeyPressed);
   FlushKeyboard;
   DisableGfxMouse;
   SetTextMode;
  end else begin
   SetTextMode;
   Writeln;
   Writeln(' Sorry, this mode is not supported...'); xReadKey;
  end;
  until false;
 end.
