program FastPCX;

{$g+,i-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,x+,i-,n-}

(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 Copyright (c) 1996-98 by Vadim Bodrov  |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

 uses MegaGraf,Images,MemPlus,Keyboard,Fonts,i80386;

 var PCXPtr:    Pointer;
     Sprite:    Pointer;
     PCXH,PCXW: Word;
     X,Y:       Word;

 begin
  PCXPtr:=LoadFile('amber.pcx');
  if PCXPtr=nil then begin
   Writeln(' Can`t load amber.pcx');
   exit;
  end;
  GetPCXWH(PCXW,PCXH,PCXPtr);
  InitVBE;
  SetChars(@Rus8x14c,1,14,0,1);

  SetMCGAMode;
  PutStringXY(50,90,'MCGA Mode 320x200 colors',VGAWhite);
  xReadKey;
  PutPCX(Random(mgXRes)-50,Random(mgYRes)-100,PCXPtr,true);
  repeat
   PutPCX(Random(mgXRes)-50,Random(mgYRes)-100,PCXPtr,false);
  until xKeyPressed; xReadKey;

  if SetModeX(ModeX320x240) then begin
   ClearPage;
   PutStringXY(60,100,'X Mode 320x240 colors',VGAWhite);
   xReadKey;
   PutPCX(Random(mgXRes)-50,Random(mgYRes)-100,PCXPtr,true);
   repeat
    PutPCX(Random(mgXRes)-50,Random(mgYRes)-100,PCXPtr,false);
   until xKeyPressed; xReadKey;
  end;

  if SetSVGAMode(640,480,grSVGA256) then begin
   ClearPage;
   PutStringXY(230,220,'SVGA 640x480 256 colors',VGAWhite);
   xReadKey;
   PutPCX(0,0,PCXPtr,true);
   GetBuffer(Sprite,LongMul(PCXH,PCXW));
   if Sprite=nil then begin
    SetTextMode;
    Writeln(' Low Memory');
    exit;
   end;
   GetSprite(0,0,PCXW-1,PCXH-1,false,Sprite);
   repeat
    X:=Random(mgYRes)-50;
    Y:=Random(mgYRes)-100;
    PutSprite(X,Y,X+PCXW-1,Y+PCXH-1,false,Sprite);
   until xKeyPressed; xReadKey;
   FreeBuffer(Sprite,LongMul(PCXH,PCXW));
  end;

  if SetSVGAMode(640,480,grSVGA64k) then begin
   ClearPage;
   PutStringXY(230,220,'SVGA 640x480 64K colors',RGBColor($FF,$FF,$FF));
   xReadKey;
   PutPCX(0,0,PCXPtr,false);
   GetBuffer(Sprite,2*LongMul(PCXH,PCXW));
   if Sprite=nil then begin
    SetTextMode;
    Writeln(' Low Memory');
    exit;
   end;
   GetSprite(0,0,PCXW-1,PCXH-1,false,Sprite);
   repeat
    X:=Random(mgYRes)-50;
    Y:=Random(mgYRes)-100;
    PutSprite(X,Y,X+PCXW-1,Y+PCXH-1,false,Sprite);
   until xKeyPressed; xReadKey;
   FreeBuffer(Sprite,2*LongMul(PCXH,PCXW));
  end;

  if SetSVGAMode(640,480,grSVGA16M) then begin
   ClearPage;
   PutStringXY(230,220,'SVGA 640x480 16M colors',RGBColor($FF,$FF,$FF));
   xReadKey;
   PutPCX(0,0,PCXPtr,false);
   GetBuffer(Sprite,3*LongMul(PCXH,PCXW));
   if Sprite=nil then begin
    SetTextMode;
    Writeln(' Low Memory');
    exit;
   end;
   GetSprite(0,0,PCXW-1,PCXH-1,false,Sprite);
   repeat
    X:=Random(mgYRes)-50;
    Y:=Random(mgYRes)-100;
    PutSprite(X,Y,X+PCXW-1,Y+PCXH-1,false,Sprite);
   until xKeyPressed; xReadKey;
   FreeBuffer(Sprite,3*LongMul(PCXH,PCXW));
  end;

  if SetSVGAMode(640,480,grSVGA4G) then begin
   ClearPage;
   PutStringXY(230,220,'SVGA 640x480 16M colors',RGBColor($FF,$FF,$FF));
   xReadKey;
   PutPCX(0,0,PCXPtr,false);
   GetBuffer(Sprite,4*LongMul(PCXH,PCXW));
   if Sprite=nil then begin
    SetTextMode;
    Writeln(' Low Memory');
    exit;
   end;
   GetSprite(0,0,PCXW-1,PCXH-1,false,Sprite);
   repeat
    X:=Random(mgYRes)-50;
    Y:=Random(mgYRes)-100;
    PutSprite(X,Y,X+PCXW-1,Y+PCXH-1,false,Sprite);
   until xKeyPressed; xReadKey;
   FreeBuffer(Sprite,4*LongMul(PCXH,PCXW));
  end;

  SetTextMode;
 end.