{$g+,i-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,x+,i-,n-}

 uses MemPlus,MegaGraf,Keyboard,i80386,Fonts,DOSUtil,ZenTimer;

(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}


 var White: LongInt;
     Mode:  Word;
     VbePresent: Boolean;
     WaitForRetrace: Boolean;
     VScroll: Boolean;
     HScroll: Boolean;
     Modes: array [0..99] of Word;
     MX, MY, SX, SY:   Word;
     DX, DY: Word;

 procedure xDelay (X: Word);
 var i: Word;
 begin
  for i:=0 to X do HRetrace;
 end;

 function RConv(R: LongInt): String;
 begin
  RConv:=IntToStr(LongDiv(R,10))+'.'+IntToStr(R mod 10);
 end;


 procedure MainInfo;
 begin
  Writeln;
  Writeln(' MEGATEST 1.0 (English Version)');
  Writeln(' X Modes and VESA VBE 1.2/2.0 modes compatibility test');
  Writeln(' This program is a part of PLUS SYSTEM PRO 2.0 for Borland Pascal');
  Writeln(' Copyright (c) Vadim Bodrov 1996-98 (mail me: falkoris@hotmail.com)');
  Writeln;
 end;

 procedure ShowVBEInfo;
 begin
  if VBEPresent then begin
   Writeln(' Main info:');
   Writeln(' - OEM string:                 ',mgOEMString);
   Writeln(' - VBE version:                ',Hi(mgVBEVersion),'.',Lo(mgVBEVersion));
   Write  (' - 8 bit DAC:                  ');
   if (mgCapabilities and 1)=1 then Writeln('Yes') else Writeln('No');
   Write  (' - Normal DAC operations:      ');
   if (mgCapabilities and 4)=0 then Writeln('Yes') else Writeln('No');
   Writeln(' - Granulation:                '+IntToStr(mgWinGran));
   Writeln(' - Total video memory:         '+IntToStr(mgVBEMem)+' K');
  end;
 end;

 procedure MainMenu;
 var Key:       Char;
     nn,i,j,k:  Byte;
     v:         Char;
 begin
  repeat
   SetTextMode;
   FillScr(' ',15);
   HideCursor;
   MainInfo;
   if VBEPresent then begin
    ShowVBEInfo;
   end;
   Writeln;
   Writeln(' [1] - X Mode Test');
   if VBEPresent then begin
    Writeln(' [2] - VBE 256 colors test (08 bpp) PaletteColor');
    Writeln(' [3] - VBE 32K colors test (15 bpp) HiColor');
    Writeln(' [4] - VBE 64K colors test (16 bpp) HiColor');
    Writeln(' [5] - VBE 16M colors test (24 bpp) TrueColor');
    Writeln(' [6] - VBE 16M colors test (32 bpp) TrueColor');
    v:='7';
   end else v:='2';
   Writeln(' [0] - Exit');
   FillChar(Ptr(SEGB800,23*160)^,160,4*16+15);
   repeat
    xGotoXY(1,24);
    Write  (' | <R> wait retrace  - ');
    if WaitForRetrace then Write ('YES') else Write ('NO');
    Write ('  |  <P> SVGA (VESA/VBE) pages No.           - ');
    if not mgUseMaxPages then Write ('NORM.') else Write ('MAX. ');
    Write ('| ');
    Key:=xReadKey;
    if UpCase(Key)='R' then WaitForRetrace:=not WaitForRetrace;
    if UpCase(Key)='P' then mgUseMaxPages:=not mgUseMaxPages;
   until (Key>='0') and (Key<v);
   if Key='0' then begin
   FillScr(' ',7);
   Stretch(0);
   MainInfo;
   ShowCursor;
   Writeln('  ͻ         ͻ ͻ');
   Writeln('  ͼ    ͻ ͻ  ͻ   ͼ   ');
   Writeln(' ڽ   ͼͼ  ͼ͹ ͼ  ͼ   ');
   Writeln('           ͻ  ͼ                 ');
   Writeln('   :     ͹˻ ͻ  .Ĵ');
   Writeln(' |. |  .    ͼ              *    ');
   Writeln('  -+-    . ʼ       ʼ     ʼ   .  +  ');
   Writeln('   |   .        version 2.0       .      :  ');
   Writeln(' . Copyright (c) 1996-98 by Vadim Bodrov   |');
   Writeln(' |      ULTRA FAST GRAPHIC/GAME SDK FOR      ');
   Writeln(' TURBO/BORLAND PASCAL (REAL MODE/DPMI16)!!! ');
   Writeln('        SUPPORT: MCGA, X MODE (12 types),    ');
   Writeln('   SVGA (256, 32K, 64K, 16M, 16M+A COLORS),  ');
   Writeln('    MIDPAK AND DIGPAK FROM AUDIO SOLUTION  ');
   Writeln('    IDEAL FOR GRAPHIC, GAMES, DEMOS etc.   ');
   for i:=1 to 15 do begin
    CLIRetrace;
    CLIRetrace;
    Stretch(i);
   end;
   xDelay(20000);
   ExitCode:=0; Halt;
  end;
  SetTextMode;
  FillScr(' ',15);
  HideCursor;
  MainInfo;
  if Key='1' then begin
   Writeln(' [1] - X Mode 320x200');
   Writeln(' [2] - X Mode 320x240');
   Writeln(' [3] - X Mode 360x200');
   Writeln(' [4] - X Mode 360x240');
   Writeln(' [5] - X Mode 376x282');
   Writeln(' [6] - X Mode 320x400');
   Writeln(' [7] - X Mode 320x480');
   Writeln(' [8] - X Mode 360x400');
   Writeln(' [9] - X Mode 360x480');
   Writeln(' [A] - X Mode 360x360');
   Writeln(' [B] - X Mode 376x308');
   Writeln(' [C] - X Mode 376x564');
   j:=12;
   nn:=1;
  end else begin
   nn:=Byte(Key)-48;
   inc(nn,2);
   i:=0;
   j:=0;
   repeat
    if mgVBEModesList[i].ColorMode=nn then begin
     Modes[j]:=mgVBEModesList[i].VideoMode;
     inc(j);
     Write(' [');
     if j<10 then Write(j) else Write(Chr(j-10+Byte('A')));
     Writeln('] -',' VBE Mode ',WordToHEX(mgVBEModesList[i].VideoMode)+'h ',
             mgVBEModesList[i].XRes,'x',mgVBEModesList[i].YRes);
    end;
    inc(i);
   until i>=mgVBEModes;
   if j=0 then Writeln(' This modes not supported!');
   Writeln;
  end;
  Writeln(' [0] - Main menu');
  FillChar(Ptr(SEGB800,23*160)^,160,1*16+11);
  repeat
    xGotoXY(1,24);
    Write  (' |  <V> do vertical scrolling  - ');
    if VScroll then Write ('YES') else Write ('NO ');
    Write ('    |  <H> do horizontal scrolling  - ');
    if HScroll then Write ('YES') else Write ('NO ');
    Write (' | ');
    Key:=xReadKey;
    if UpCase(Key)='V' then VScroll:=not VScroll;
    if UpCase(Key)='H' then HScroll:=not HScroll;
    if Key in ['0'..'9'] then k:=Byte(Key)-48;
    if Key>='A' then k:=Byte(Key)-55;
    if Key>='a' then k:=Byte(Key)-87;
   until (k>=0) and (k<=j);
  until k>0;
  if nn=1 then Mode:=k-1 else Mode:=Modes[k-1];
 end;

 procedure MainWindow (Title, Status: String);
 begin
  ClearPage;
  SetWindow(0,0,GetMaxX,GetMaxY);
  PutStringXY((GetMaxX-Length(Title)*8) div 2,1,Title,White);
  PutStringXY((GetMaxX-Length(Status)*8) div 2,GetMaxY-15,Status,White);
  DrawRectangle(0,0,GetMaxX,GetMaxY,White);
  DrawHLine(0,GetMaxX,16,White);
  DrawHLine(0,GetMaxX,GetMaxY-16,White);
  SetWindow(1,17,GetMaxX-1,GetMaxY-17);
 end;

 procedure FillPattern;
 var S, SD:    String;
     Value, i: LongInt;
 begin
  GetWindow(SX,SY,MX,MY);
  if mgColorMode>GrSVGA256 then begin
   for i:=SX to MX do begin
    DrawLine(MX shr 1,MY shr 1,i,SY,RGBColor((i*mgRedMask) div MX,0,0));
    DrawLine(MX shr 1,MY shr 1,i,MY,RGBColor(0,(i*mgGreenMask) div MX,0));
   end;
   for i:=SY to MY do begin
    value:=Word((i*mgBlueMask) div MY);
    DrawLine(MX shr 1,MY shr 1,SX,i,RGBColor(value,0,mgBlueMask-value));
    DrawLine(MX shr 1,MY shr 1,MX,i,RGBColor(0,mgGreenMask-value,value));
   end;
  end else begin
   i:=SX;
   repeat
    DrawLine(MX shr 1,MY shr 1,i,SY,i mod 255);
    DrawLine(MX shr 1,MY shr 1,i,MY,(i+1) mod 255);
    inc(i,4);
   until (i>MX);
   i:=SY;
   repeat
    DrawLine(MX shr 1,MY shr 1,SX,i,(i+2) mod 255);
    DrawLine(MX shr 1,MY shr 1,MX,i,(i+3) mod 255);
    inc(i,4);
   until (i>MY);
  end;
  Str(mgXRes,SD);
  S:=SD+'x';
  Str(mgYRes,SD);
  S:=S+SD;
  if mgColorMode>GrModeX then S:='VESA '+WordToHex(Mode)+'h, '+S
  else S:='X MODE, '+S;
  case mgBitsPerPixel of
   8 : S:=S+' 256';
   15: S:=S+' 32K';
   16: S:=S+' 64K';
   24: S:=S+' 16M';
   32: S:=S+' 16M+A';
  end;
  S:=S+' COLORS';
  PutStringXY(10,26,S,White);
  Str(MX+1,S);
  PutStringXY(10,42,'PIXELS PER LINE '+S,White);
  Str(MY+1,S);
  PutStringXY(10,58,'HIGH OF PAGE IN PIXELS '+S,White);
  Str(mgBytesPerLine,S);
  PutStringXY(10,74,'BYTES PER SCAN LINE '+S,White);
  Str(mgMaxPages,S);
  PutStringXY(10,90,'YOU HAVE '+S+' PAGES',White);
 end;

 procedure EllipseDemo;
 var MaxRadius: Word;
     Color:     LongInt;
 begin
  MainWindow('Ellipse demonstration','Press `esc` to abort');
  MaxRadius:=GetMaxY div 10;
  repeat
   Color:=LongMul(Random($FFFF),Random($FF));
   mgBorderColor:=not Color;
   FilledEllipse(Random(GetMaxX),Random(GetMaxY),Random(MaxRadius),
    Random(MaxRadius),Color);
  until xKeyPressed;
 end;

 function TriangleTest: LongInt;
 var Color: LongInt;
 begin
  MX:=GetMaxX;
  MY:=GetMaxY;
  MainWindow('Triangle demonstration','Press `esc` to abort');
  repeat
   Color:=LongMul(Random($FFFF),Random($FF));
   mgBorderColor:=not Color;
   FilledTriangle(Random(MX),Random(MY),Random(MX),Random(MY),
                  Random(MX),Random(My),Color);
  until xKeyPressed;
 end;

 procedure AspectRatioDemo;
 var CenterX: Integer;
     CenterY: Integer;
     Radius: Word;
     i: LongInt;
     AspInc,Asp: Real;
     RadiusStep: Word;
 begin
  MainWindow('Aspect Ratio demonstration','Press `esc` to abort');
  Asp:=mgAspectRatio;
  CenterX:=GetMaxX div 2;
  CenterY:=17+(GetMaxY-34) div 2;
  Radius:=Round((GetMaxY-34)/Asp/2);
  RadiusStep:=(Radius div 30);
  DrawCircle(CenterX,CenterY,Radius,White);
  AspInc:=Asp/30;
  for i:=1 to 30 do begin
   mgAspectRatio:=mgAspectRatio-AspInc;
   DrawCircle(CenterX,CenterY,Radius,White);
   Dec(Radius,RadiusStep);
  end;
  Inc(Radius,RadiusStep*30);
  mgAspectRatio:=Asp;
  for i:=1 to 30 do begin
   mgAspectRatio:=mgAspectRatio+AspInc;
   if Radius>RadiusStep then Dec(Radius,RadiusStep);
   DrawCircle(CenterX,CenterY,Radius,White);
  end;
  mgAspectRatio:=Asp;
 end;

 procedure LineStyleDemo;
 var X,Y      : Word;
     i,M      : Word;
 begin
  MainWindow('User defined line styles','');
  X:=4;
  Y:=10;
  M:=GetMaxX div 2;
  mgLineStyle:=$FFFF;
  while X<GetMaxX-4 do begin
    if X >= M then mgThickLine:=true;
    mgLineStyle:=mgLineStyle or (1 shl (i mod 16));
    DrawLine(X,Y,X,GetMaxY-Y,White);
    Inc(X,6);
    Inc(i);
    if mgLineStyle=$FFFF then begin
     i:=0;
     mgLineStyle:=0;
    end;
   end;
   mgThickLine:=false;
  end;

 procedure FlipDemo;
 var i, j, iStep, jStep, APage, Vpage: Integer;
     MX, MY: Word;
     fpsRate, midRate: LongInt;
     lastCount, newCount: LongInt;
     S1, S2, S3: String;
 begin
  SetWindow(0,0,GetMaxX,GetMaxY);
  mgLineStyle:=$FFFF;
  MX:=mgXRes-1; MY:=mgYRes-1; fpsRate:=0;
  if mgMaxPages>1 then begin
   VPage:=0; APage:=1;
   SetActivePage(APage);
   SetVisualPage(VPage,true);
   ClearVideoMem;
   i:=0; j:=MX; iStep:=2; jStep:=-2;
   mgBkGrColor:=0;
   S3:='0';
   Str(mgMaxPages,S2);
   LastCount:=0;
   midRate:=0;
   LZTimerOn;
   repeat
    SetActivePage(APage);
    ClearPage;
    PutStringXY(10,10,'Pages switch',White);
    PutStringXY(10,26,'FPS rate '+RConv(fpsRate)+' FPS, Page '+IntToStr(APage+1)+' of '+S2,White);
    DrawLine(i,0,MX-i,MY,White);
    DrawLine(0,MY-j,MX,j,White);
    DrawHLine(0,MX,0,White); DrawLine(MX,0,MX,MY,White);
    DrawHLine(0,MX,MY,White); DrawLine(0,MY,0,0,White);
    VPage:=(VPage+1) mod (mgMaxPages);
    SetVisualPage(VPage,WaitForRetrace);
    if APage=0 then begin
      newCount:=LZTimerLap;
      fpsRate:=Word(LongDiv(10000000,LongSub(newCount,lastCount)))*(mgMaxPages);
      if midRate=0 then midRate:=fpsRate else midRate:=LongShr(LongAdd(midRate,fpsRate),1);
      lastCount:=newCount;
    end;
    APage:=(APage+1) mod (mgMaxPages);
    inc(i,iStep);
    if i>MX then begin
     i:=MX-2;
     iStep:=-2;
    end;
    if i<0 then begin i:=2; iStep:=2; end;
    inc(j,jStep);
    if j>MY then begin j:=MY-2; jStep:=-2; end;
    if j<0 then begin j:=2; jStep:=2; end;
  until (xKeyPressed);
  LZTimerOff;
  SetActivePage(0);
  SetVisualPage(0,true);
  xReadKey;
  end;
 end;

 procedure ScrollDemo;
 var i: Word;
 begin
  if HScroll then begin
   ClearVideoMem;
   if not SetScreenStart(10,0,false) then exit;
   SetScreenStart(0,0,false);
   MY:=mgYRes;
   i:=LongDiv(LongDiv(mgWorkMem,mgYRes+1),mgBytesPerPixel);
   repeat
    SetLogicalSize(i,my);
    GetLogicalSize(mx,my);
    dec(i);
   until (mx>mgXRes) or (i<mgXRes);
   if (mgXRes<mx) and (mgXRes<i) then begin
    MainWindow('Horizontal scrolling demo','Press `esc` to abort');
    FillPattern;
    FlushKeyboard; xReadKey;
    for i:=0 to (MX-mgXRes+2) do begin
     SetScreenStart(i,0,false);
     xDelay(20);
    end;
    xDelay(10000);
    for i:=(MX-mgXRes+1) downto 0 do begin
     SetScreenStart(i,0,false);
     xDelay(20);
    end;
   end;
  end;
  if VScroll then begin
   ClearVideoMem;
   if not SetScreenStart(0,10,false) then exit;
   SetScreenStart(0,0,false);
   my:=LongDiv(LongDiv(mgWorkMem,mgXRes),mgBytesPerPixel);
   SetLogicalSize(mgXRes,my);
   GetLogicalSize(mx,my);
   if mgYRes<my then begin
   MainWindow('Vertical scrolling demo','Press `esc` to abort');
   FillPattern;
   FlushKeyboard; xReadKey;
   for i:=0 to (MY-mgYRes+2) do begin
    SetScreenStart(0,i,false);
    xDelay(20);
   end;
   xDelay(10000);
   for i:=(MY-mgYRes+1) downto 0 do begin
    SetScreenStart(0,i,false);
    xDelay(20);
   end;
   FlushKeyboard;
  end;
  end;
  SetLogicalSize(mgXRes,mgYRes);
  SetWindow(0,0,GetMaxX,GetMaxY);
 end;

 procedure DrawSprite;
 var
   RedColor,BlueColor,YellowColor: Longint;
 begin
  ClearPage;
  if mgColorMode<grSVGA32K then begin
   BlueColor:=VGABlue;
   YellowColor:=VGAYellow;
   RedColor:=VGARed;
  end else begin
   mgMaskColor:=RGBColor(0,0,0);
   BlueColor:=RGBColor(1,1,255);
   RedColor:=RGBColor(255,1,1);
   YellowColor:=RGBColor(255,255,1);
  end;
  DX:=200;
  mgBorderColor:=BlueColor;
  mgMaskColor:=RedColor;
  DY:=Round(mgAspectRatio*200)-1;
  mgUseBorderColor:=false;
  FilledRectangle(0,0,DX-1,DY-1,RedColor);
  mgUseBorderColor:=true;
  FilledCircle(100,DY div 2,72,YellowColor);
  FilledCircle(64,DY div 3,6,BlueColor);
  FilledCircle(136,DY div 3,6,BlueColor);
  DrawLine(99,DY div 3,99,(DY div 3)+(DY div 5),BlueColor);
  DrawLine(100,DY div 3,100,(DY div 3)+(DY div 5),BlueColor);
  DrawLine(60,2*(DY div 3),140,2*(DY div 3),BlueColor);
  DrawLine(66,2*(DY div 3)+1,134,2*(DY div 3)+1,BlueColor);
  DrawLine(72,2*(DY div 3)+2,128,2*(DY div 3)+2,BlueColor);
 end;

 procedure SpriteDemo;
 var x,y: Word;
     P: Pointer;
 begin
  GetLogicalSize(MX,MY);
  Dec(MX);
  Dec(MY);
  DrawSprite;
  GetBuffer(P,LongMul(LongMul((DY+1),200),mgBytesPerPixel));
  if P=nil then exit;
  GetSprite(0,0,DX-1,DY-1,false,P);
  ClearPage;
  MainWindow('Sprite blt. demo','Press `esc` to abort');
  repeat
   x:=Random(MX+DX)-DX;
   y:=Random(MY+DY)-DX;
   PutSprite(x,y,x+DX-1,y+DY-1,false,P);
  until xKeyPressed;
  xReadKey;
  ClearPage;
  SetTransp(true);
  MainWindow('Transparent sprite blt. demo','Press `esc` to abort');
  repeat
   x:=Random(MX+DX)-DX;
   y:=Random(MY+DY)-DX;
   PutSprite(x,y,x+DX-1,y+DY-1,false,P);
  until xKeyPressed;
  FreeBuffer(P,LongMul(LongMul((DY+1),200),mgBytesPerPixel));
  SetTransp(false);
 end;

 procedure PaletteDemo;
 begin
  MainWindow('Palette demonstration','Press `esc` to abort');
  FillPattern;
  GetVGAPalette(mgBufferPtr,0,256);
  GetVGAPalette(GetPtr(mgBufferPtr,768),0,256);
  FlushKeyboard;
  xReadKey;
  repeat
   CliRetrace;
  until not FadePalette(mgBufferPtr,0,256,0);
  xDelay(2000);
  repeat
   CliRetrace;
  until not EvenPalette(mgBufferPtr,GetPtr(mgBufferPtr,768),0,256);
 end;

 procedure SplitDemo;
 var i: Word;
 begin
  if mgMaxPages>1 then begin
   ClearVideoMem;
   MainWindow('Split screen demonstartion','Press `esc` to abort');
   FillPattern;
   SetActivePage(1);
   MainWindow('Split screen demonstartion','Press `esc` to abort');
   for i:=0 to GetMaxX do DrawLine(i,0,i,GetMaxY,i*1000);
   SetActivePage(0);
   SetVisualPage(1,true);
   MX:=0;
   i:=1;
   repeat
    SetSplitLine(MX shl 1);
    MX:=MX+i;
    if (MX=0) or (MX=(mgYRes shr 1)-1) then i:=-i;
    xDelay(100);
   until xKeyPressed;
   SetSplitLine(0);
   SetVisualPage(0,true);
   xReadKey;
  end;
 end;

begin
 VbePresent:=InitVBE;
 WaitForRetrace:=true;
 repeat
  MainMenu;
  if Mode<12 then SetModeX(Mode) else SetVBEMode(Mode);
  mgUseBorderColor:=true;
  SetChars(@LAT8x16,1,16,0,1);
  if mgColorMode <= grSVGA256 then
   White:=VGAWhite
  else
   White:=RGBColor($FF,$FF,$FF);
  MainWindow('Pattern demonstration','Press `esc` to abort');
  FillPattern;
  xReadKey;
  if (VScroll) or (HScroll) then begin
   ScrollDemo;
   xReadKey;
  end;
  EllipseDemo;
  xReadKey;
  TriangleTest;
  xReadKey;
  AspectRatioDemo;
  xReadKey;
  LineStyleDemo;
  xReadKey;
  FlipDemo;
  SpriteDemo;
  xReadKey;
  if mgColorMode<grSVGA32K then begin
   PaletteDemo;
   xReadKey;
  end;
  SplitDemo;
  SetTextMode;
 until false;
end.