{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 Copyright (c) 1996-98 by Vadim Bodrov  |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

 uses MegaGraf,MemPlus,Keyboard,Fonts;

 const NumFigures=   4;

 var BkAddr:         array [0..NumFigures] of Pointer;
     X:              array [0..NumFigures] of Integer;
     Y:              array [0..NumFigures] of Integer;
     DX:             array [0..NumFigures] of Integer;
     DY:             array [0..NumFigures] of Integer;
     i,Line:         Word;
     GridBlue:       Byte;
     PageTitleColor: Byte;
     PallBuf:        array [0..767] of Byte;

 procedure InitFigures;
 begin
  for i:=1 to NumFigures do begin
   X[i]:=Random(600)+20;
   Y[i]:=Random(600)+160;
   DX[i]:=Random(NumFigures)+1;
   DY[i]:=Random(NumFigures)+1;
   GetBuffer(BkAddr[i],20*20);
   GetSprite(X[i],Y[i],X[i]+19,Y[i]+19,false,BkAddr[i]);
  end;
 end;

 procedure MoveFigures;
 begin
  for i:=1 to NumFigures do begin
   PutSprite(X[i],Y[i],X[i]+19,Y[i]+19,false,BkAddr[i]);
   if (X[i]>=618) or (X[i]<=1) then DX[i]:=-DX[i];
   if (Y[i]>=338*2+110) or (Y[i]<=146) then DY[i]:=-DY[i];
   inc(X[i],DX[i]); inc(Y[i],DY[i]);
  end;
  for i:=1 to NumFigures do GetSprite(X[i],Y[i],X[i]+19,Y[i]+19,false,BkAddr[i]);
  for i:=1 to NumFigures do begin
   if (i and 1)=1 then DrawEllipse(X[i]+10,Y[i]+10,8,8,i+70)
   else FilledRectangle(X[i],Y[i],X[i]+19,Y[i]+19,90+i);
  end;
 end;

 procedure ShowScreen;
 begin
  PageTitleColor:=63;
  GridBlue:=42;
  SetVGAPal(100,0,0,GridBlue);
  for i:=0 to 63 do DrawLine(i*10,142,i*10,817,100);
  DrawLine(639,142,639,817,100);
  for i:=14 to 81 do DrawLine(0,i*10,639,i*10,100);
  PutStringXY(230,142+160,' - PAGE NUMBER ONE -',101);
  PutStringXY(230,142+338+160,' - PAGE NUMBER TWO -',102);
  FilledRectangle(0,0,639,70,VGARed);
  FilledRectangle(0,71,639,138,VGABlue);
  DrawRectangle(0,0,639,139,VGAWhite);
  DrawLine(0,70,639,70,VGAWhite);
  PutStringXY(170,10,'Use Up/Down keys to scroll the screen',VGAWhite);
  PutStringXY(160,30,'Use Left/Right keys to ajast grid color',VGAWhite);
  PutStringXY(250,50,'Press `Esc` to exit',VGAWhite);
  PutStringXY(120,80,'Split screen will help you to get two visual pages',VGAWhite);
  PutStringXY(130,100,'in SVGA 640x480x256 mode on 512K video adapters!',VGAWhite);
 end;

 begin
  SetChars(@Rus8x16d,1,16,0,1);
  InitVBE;
  SetVBEMode($101);
  ClearVideoMem;
  SetLogicalSize(640,819);
  SetSplitLine(337);
  SetScreenStart(0,142,false);
  ShowScreen;
  InitFigures;
  line:=140;
  MultiKeysInit;
  FlushKeys:=true;
  repeat
   MoveFigures;
   if (TestKey(Up_Scan)) and (Line>142) then Dec(Line,6);
   if (TestKey(Down_Scan)) and (Line<142+338) then Inc(Line,6);
   if (TestKey(Left_Scan)) and (GridBlue>10) then Dec(GridBlue);
   if (TestKey(Right_Scan)) and (GridBlue<63) then Inc(GridBlue);
   SetVGAPal(100,0,0,GridBlue);
   inc(PageTitleColor); if PageTitleColor>63 then PageTitleColor:=0;
   SetVGAPal(101,PageTitleColor,PageTitleColor,PageTitleColor);
   SetVGAPal(102,PageTitleColor,PageTitleColor,0);
   SetScreenStart(0,Line,true);
  until TestKey(Esc_Scan);
  GetVGAPalette(@PallBuf[0],0,256);
  repeat
   MoveFigures;
   Retrace;
   MoveFigures;
   Retrace;
  until not FadePalette(@PallBuf[0],16,240,0);
  SetScreenStart(0,142,true);
  PutStringXY(270,142+338+160,' - THE END -',15);
  PutStringXY(220,142+338+190,' press any key to exit...',15);
  for i:=142 div 4 to (142+338) div 4 do SetScreenStart(0,i*4,true);
  MultiKeysDone;
  xReadKey;
  SetTextMode;
 end.