{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 Copyright (c) 1996-98 by Vadim Bodrov  |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

 uses MegaGraf,MemPlus,Keyboard,DosUtil,Fonts;

 const NumFigures=   8;

 var BkAddr:         array [0..NumFigures] of Pointer;
     X:              array [0..NumFigures] of Integer;
     Y:              array [0..NumFigures] of Integer;
     DX:             array [0..NumFigures] of Integer;
     DY:             array [0..NumFigures] of Integer;
     SX,SY,i:        Word;
     PallBuf:        array [0..767] of Byte;

 procedure InitFigures;
 begin
  for i:=1 to NumFigures do begin
   X[i]:=Random(600)+20;
   Y[i]:=Random(370)+20;
   DX[i]:=Random(NumFigures div 2)+1;
   DY[i]:=Random(NumFigures div 2)+1;
   GetBuffer(BkAddr[i],10*10);
   GetSprite(X[i],Y[i],X[i]+9,Y[i]+9,false,BkAddr[i]);
  end;
 end;

 procedure MoveFigures;
 begin
  for i:=1 to NumFigures do begin
   PutSprite(X[i],Y[i],X[i]+9,Y[i]+9,false,BkAddr[i]);
   if (X[i]>=620) or (X[i]<=10) then DX[i]:=-DX[i];
   if (Y[i]>=380) or (Y[i]<=10) then DY[i]:=-DY[i];
   inc(X[i],DX[i]); inc(Y[i],DY[i]);
  end;
  for i:=1 to NumFigures do GetSprite(X[i],Y[i],X[i]+9,Y[i]+9,false,BkAddr[i]);
  for i:=1 to NumFigures do begin
  if (i and 1)=1 then DrawRectangle(X[i],Y[i],X[i]+9,Y[i]+9,i+7)
  else FilledRectangle(X[i],Y[i],X[i]+9,Y[i]+9,i+7);
  end;
 end;

 begin
  SetTextMode;
  FillScr(' ',15);
  xGotoXY(4,11);
  SetFont(@Rus8x16c,16);
  Writeln(' Press any key to make your own virtual world 640x400 in X Mode 320x200...');
  xGotoXY(14,13);
  Writeln(' hint: use arrow keys to scroll around the screen');
  xReadKey;
  SetModeX(ModeX320x200);
  SetLogicalSize(640,400);
  for i:=1 to 63 do DrawLine(i*10,0,i*10,399,VGARed);
  for i:=1 to 39 do DrawLine(0,i*10,639,i*10,VGARed);
  DrawRectangle(0,0,639,399,15);
  SX:=0; SY:=0;
  MultiKeysInit;
  FlushKeys:=true;
  InitFigures;
  repeat
   MoveFigures;
   if (TestKey(Up_Scan)) and (SY>0) then Dec(SY,2);
   if (TestKey(Down_Scan)) and (SY<200) then Inc(SY,2);
   if (TestKey(Left_Scan)) and (SX>0) then Dec(SX,2);
   if (TestKey(Right_Scan)) and (SX<320) then Inc(SX,2);
   SetScreenStart(SX,SY,true);
  until TestKey(Esc_Scan);
  GetVGAPalette(@PallBuf[0],0,256);
  repeat
   MoveFigures;
   Retrace;
   MoveFigures;
   Retrace;
  until not FadePalette(@PallBuf[0],0,32,0);
  MultiKeysDone;
  SetTextMode;
 end.