{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*  USEFULL GRAPHIC UTILITY /I80386 AND HIGHER, REAL MODE, PROTECTED MODE  *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit GfxUtil;

 interface

 var GfxPalAddr: Pointer;

 procedure SetBankREALTEK;
 procedure SetBankCIRRUS;
 procedure SetBankCIRRUS2M;
 procedure SetBankATI;
 procedure SetBankAHEADA;
 procedure SetBankAHEADB;
 procedure SetBankTRIDENT;
 procedure SetBankOAK;
 procedure SetBankPARADISE;
 procedure SetBankNCR;
 procedure SetBankGEONA;
 procedure SetBankCOMPAQ;
 procedure SetBankET3000;
 procedure SetBankET4000;
 procedure SetBankET4000W32;
 procedure SetBankSPEEDSTAR24;
 procedure SetBankV7VRAM2;

 procedure MCGABlur (ScrAddr: Pointer);
 procedure MCGAFadeUp (X, Y, X1, Y1: Word; ScrAddr: Pointer);
 procedure MCGAWuLine (X0, Y0, X1, Y1: Integer; BaseCol, Levels, Intensity: Word);
 procedure SetLinecomp (Addr: Word);
 procedure BaseVGA (ScrollX, ScrollY: Integer; Slide: Word);
 procedure ScreenPan (Offs: Word);

 procedure ConvertLine256to16M (const SrcAddr, DstAddr: Pointer; const Length: Word);
 procedure ConvertLine256to4G (const SrcAddr, DstAddr: Pointer; const Length: Word);
 procedure ConvertLine256to32K (const SrcAddr, DstAddr: Pointer; const Length: Word);
 procedure ConvertLine16Mto32K (const SrcAddr, DstAddr: Pointer; const Length: Word);
 procedure ConvertLine16Mto4G (const SrcAddr, DstAddr: Pointer; const Length: Word);

 procedure PutSprite256to32K (X1, Y1, X2, Y2: Integer; DY: Boolean; Addr: Pointer);
 procedure PutSprite256to16M (X1, Y1, X2, Y2: Integer; DY: Boolean; Addr: Pointer);
 procedure PutSprite256to4G (X1, Y1, X2, Y2: Integer; DY: Boolean; Addr: Pointer);
 procedure PutSprite16Mto32K (X1, Y1, X2, Y2: Integer; DY: Boolean; Addr: Pointer);
 procedure PutSprite16Mto4G (X1, Y1, X2, Y2: Integer; DY: Boolean; Addr: Pointer);

 procedure XorLine256Fast (X1, Y1, X2, Y2: Integer; Color: LongInt);
 procedure OrLine256Fast (X1, Y1, X2, Y2: Integer; Color: LongInt);
 procedure AndLine256Fast (X1, Y1, X2, Y2: Integer; Color: LongInt);

 procedure PAL6to8 (Addr: Pointer);
 procedure PAL8to6 (Addr: Pointer);
 procedure SetStandardPal;

 const

 VGAPal8: array [0..767] of Byte =
   ($00,$00,$00, $A8,$00,$00, $00,$A8,$00, $A8,$A8,$00,
    $00,$00,$A8, $A8,$00,$A8, $00,$54,$A8, $A8,$A8,$A8,
    $54,$54,$54, $FC,$54,$54, $54,$FC,$54, $FC,$FC,$54,
    $54,$54,$FC, $FC,$54,$FC, $54,$FC,$FC, $FC,$FC,$FC,
    $00,$00,$00, $14,$14,$14, $20,$20,$20, $2C,$2C,$2C,
    $38,$38,$38, $44,$44,$44, $50,$50,$50, $60,$60,$60,
    $70,$70,$70, $80,$80,$80, $90,$90,$90, $A0,$A0,$A0,
    $B4,$B4,$B4, $C8,$C8,$C8, $E0,$E0,$E0, $FC,$FC,$FC,
    $FC,$00,$00, $FC,$00,$40, $FC,$00,$7C, $FC,$00,$BC,
    $FC,$00,$FC, $BC,$00,$FC, $7C,$00,$FC, $40,$00,$FC,
    $00,$00,$FC, $00,$40,$FC, $00,$7C,$FC, $00,$BC,$FC,
    $00,$FC,$FC, $00,$FC,$BC, $00,$FC,$7C, $00,$FC,$40,
    $00,$FC,$00, $40,$FC,$00, $7C,$FC,$00, $BC,$FC,$00,
    $FC,$FC,$00, $FC,$BC,$00, $FC,$7C,$00, $FC,$40,$00,
    $FC,$7C,$7C, $FC,$7C,$9C, $FC,$7C,$BC, $FC,$7C,$DC,
    $FC,$7C,$FC, $DC,$7C,$FC, $BC,$7C,$FC, $9C,$7C,$FC,
    $7C,$7C,$FC, $7C,$9C,$FC, $7C,$BC,$FC, $7C,$DC,$FC,
    $7C,$FC,$FC, $7C,$FC,$DC, $7C,$FC,$BC, $7C,$FC,$9C,
    $7C,$FC,$7C, $9C,$FC,$7C, $BC,$FC,$7C, $DC,$FC,$7C,
    $FC,$FC,$7C, $FC,$DC,$7C, $FC,$BC,$7C, $FC,$9C,$7C,
    $FC,$B4,$B4, $FC,$B4,$C4, $FC,$B4,$D8, $FC,$B4,$E8,
    $FC,$B4,$FC, $E8,$B4,$FC, $D8,$B4,$FC, $C4,$B4,$FC,
    $B4,$B4,$FC, $B4,$C4,$FC, $B4,$D8,$FC, $B4,$E8,$FC,
    $B4,$FC,$FC, $B4,$FC,$E8, $B4,$FC,$D8, $B4,$FC,$C4,
    $B4,$FC,$B4, $C4,$FC,$B4, $D8,$FC,$B4, $E8,$FC,$B4,
    $FC,$FC,$B4, $FC,$E8,$B4, $FC,$D8,$B4, $FC,$C4,$B4,
    $70,$00,$00, $70,$00,$1C, $70,$00,$38, $70,$00,$54,
    $70,$00,$70, $54,$00,$70, $38,$00,$70, $1C,$00,$70,
    $00,$00,$70, $00,$1C,$70, $00,$38,$70, $00,$54,$70,
    $00,$70,$70, $00,$70,$54, $00,$70,$38, $00,$70,$1C,
    $00,$70,$00, $1C,$70,$00, $38,$70,$00, $54,$70,$00,
    $70,$70,$00, $70,$54,$00, $70,$38,$00, $70,$1C,$00,
    $70,$38,$38, $70,$38,$44, $70,$38,$54, $70,$38,$60,
    $70,$38,$70, $60,$38,$70, $54,$38,$70, $44,$38,$70,
    $38,$38,$70, $38,$44,$70, $38,$54,$70, $38,$60,$70,
    $38,$70,$70, $38,$70,$60, $38,$70,$54, $38,$70,$44,
    $38,$70,$38, $44,$70,$38, $54,$70,$38, $60,$70,$38,
    $70,$70,$38, $70,$60,$38, $70,$54,$38, $70,$44,$38,
    $70,$50,$50, $70,$50,$58, $70,$50,$60, $70,$50,$68,
    $70,$50,$70, $68,$50,$70, $60,$50,$70, $58,$50,$70,
    $50,$50,$70, $50,$58,$70, $50,$60,$70, $50,$68,$70,
    $50,$70,$70, $50,$70,$68, $50,$70,$60, $50,$70,$58,
    $50,$70,$50, $58,$70,$50, $60,$70,$50, $68,$70,$50,
    $70,$70,$50, $70,$68,$50, $70,$60,$50, $70,$58,$50,
    $40,$00,$00, $40,$00,$10, $40,$00,$20, $40,$00,$30,
    $40,$00,$40, $30,$00,$40, $20,$00,$40, $10,$00,$40,
    $00,$00,$40, $00,$10,$40, $00,$20,$40, $00,$30,$40,
    $00,$40,$40, $00,$40,$30, $00,$40,$20, $00,$40,$10,
    $00,$40,$00, $10,$40,$00, $20,$40,$00, $30,$40,$00,
    $40,$40,$00, $40,$30,$00, $40,$20,$00, $40,$10,$00,
    $40,$20,$20, $40,$20,$28, $40,$20,$30, $40,$20,$38,
    $40,$20,$40, $38,$20,$40, $30,$20,$40, $28,$20,$40,
    $20,$20,$40, $20,$28,$40, $20,$30,$40, $20,$38,$40,
    $20,$40,$40, $20,$40,$38, $20,$40,$30, $20,$40,$28,
    $20,$40,$20, $28,$40,$20, $30,$40,$20, $38,$40,$20,
    $40,$40,$20, $40,$38,$20, $40,$30,$20, $40,$28,$20,
    $40,$2C,$2C, $40,$2C,$30, $40,$2C,$34, $40,$2C,$3C,
    $40,$2C,$40, $3C,$2C,$40, $34,$2C,$40, $30,$2C,$40,
    $2C,$2C,$40, $2C,$30,$40, $2C,$34,$40, $2C,$3C,$40,
    $2C,$40,$40, $2C,$40,$3C, $2C,$40,$34, $2C,$40,$30,
    $2C,$40,$2C, $30,$40,$2C, $34,$40,$2C, $3C,$40,$2C,
    $40,$40,$2C, $40,$3C,$2C, $40,$34,$2C, $40,$30,$2C,
    $54,$54,$54, $FC,$54,$54, $54,$FC,$54, $FC,$FC,$54,
    $54,$54,$FC, $FC,$54,$FC, $54,$FC,$FC, $FC,$FC,$FC);

 implementation

 uses MemPlus,MegaGraf,i80386,Version;

 procedure SetBankREALTEK; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        mov     dx,$03D7
        out     dx,al
        popa
 end;

 procedure SetBankCIRRUS; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        shl     al,4
        push    ax
        mov     dx,$03CE
        mov     al,9
        out     dx,al
        inc     dx
        pop     ax
        out     dx,al
        dec     dx
        mov     al,8
        out     dx,al
        popa
 end;

 procedure SetBankCIRRUS2M; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        shl     al,2
        push    ax
        mov     dx,$3CE
        mov     al,$09
        out     dx,al
        inc     dx
        pop     ax
        out     dx,al
        dec     dx
        mov     al,$08
        out     dx,al
        popa
 end;

 procedure SetBankATI; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        mov     dl,al
        shl     al,4
        or      al,dl
        rol     al,1
        push    ax
        mov     dx,$01CE
        mov     al,$B2
        out     dx,al
        inc     dx
        pop     ax
        out     dx,al
        popa
 end;

 procedure SetBankAHEADA; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        mov     bx,ax
        mov     dx,[$3CE]
        mov     ax,$200F
        out     dx,ax
        mov     ax,bx
        mov     bl,al
        shl     ax,7
        mov     al,$0D
        out     dx,ax
        mov     dl,$CC
        in      al,dx
        mov     dl,$C2
        and     al,11011111b
        and     bl,$01
        shl     bl,5
        or      al,bl
        out     dx,al
        popa
 end;

 procedure SetBankAHEADB; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        mov     bx,ax
        mov     dx,[$3CE]
        mov     ax,$200F
        out     dx,ax
        mov     ax,bx
        mov     ah,al
        shl     ah,4
        or      ah,al
        mov     al,$0D
        out     dx,ax
        pop     ax
        popa
 end;

 procedure SetBankTRIDENT; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        shl     ax,8
        mov     al,$0E
        mov     dx,$3C4
        out     dx,al
        inc     dx
        shr     ax,8
        xor     al,$02
        out     dx,al
        popa
 end;

 procedure SetBankOAK; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        mov     dl,al
        shl     al,$04
        or      al,dl
        push    ax
        mov     dx,$3DE
        mov     al,$11
        out     dx,al
        inc     dx
        pop     ax
        out     dx,al
        popa
 end;

 procedure SetBankPARADISE; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        shl     al,$04
        push    ax
        mov     dx,$3CE
        mov     al,$09
        out     dx,al
        inc     dx
        pop     ax
        push    ax
        out     dx,al
        dec     dx
        mov     al,$0A
        out     dx,al
        inc     dx
        pop     ax
        out     dx,al
        popa
 end;

 procedure SetBankNCR; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        shl     al,$02
        push    ax
        mov     dx,$3C4
        mov     al,$18
        out     dx,al
        inc     dx
        pop     ax
        out     dx,al
        popa
 end;

 procedure SetBankGEONA; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        mov     dl,al
        shl     al,$03
        or      al,dl
        or      al,$40
        push    ax
        mov     al,$06
        mov     dx,$3C4
        out     dx,al
        pop     ax
        inc     dx
        out     dx,al
        popa
 end;

 procedure SetBankCOMPAQ; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        shl     al,4
        push    ax
        mov     dx,$3CE
        mov     al,$45
        out     dx,al
        inc     dx
        pop     ax
        push    ax
        out     dx,al
        dec     dx
        mov     al,$46
        out     dx,al
        inc     dx
        pop     ax
        out     dx,al
        popa
 end;

 procedure SetBankET3000; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        mov     dl,al
        shl     al,3
        or      al,dl
        or      al,$40
        mov     dx,$3CD
        out     dx,al
        popa
 end;

 procedure SetBankET4000; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        mov     dl,al
        shl     al,4
        or      al,dl
        mov     dx,$3CD
        out     dx,al
        popa
 end;

 procedure SetBankET4000W32; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        push    ax
        and     al,$0F
        mov     dl,al
        shl     al,4
        or      al,dl
        mov     dx,$3CD
        out     dx,al
        pop     ax
        and     al,$F0
        mov     dl,al
        shr     al,4
        or      al,dl
        mov     dx,$3CB
        out     dx,al
        popa
 end;

 procedure SetBankSPEEDSTAR24; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        shl     al,4
        push    ax
        mov     dx,$3CE
        mov     al,$09
        out     dx,al
        inc     dx
        pop     ax
        push    ax
        out     dx,al
        dec     dx
        mov     al,$0A
        out     dx,al
        inc     dx
        pop     ax
        out     dx,al
        popa
 end;

 procedure SetBankV7VRAM2; assembler;
      asm
        pusha
        mov     [mgCurBank],ax
        shl     al,04h
        mov     ah,al
        mov     al,0e8h
        mov     dx,03c4h
        out     dx,ax
        popa
 end;


 procedure MCGABlur(ScrAddr: Pointer); assembler;
      asm
        les     di,[ScrAddr]
        inc     di
        mov     cx,320*200
        xor     bx,bx
        jmp     @ps1
@lp1:   mov     bl,byte ptr es:[di-1]
@ps1:   xor     ax,ax
        mov     al,byte ptr es:[di]
        add     ax,bx
        mov     bl,byte ptr es:[di+1]
        add     ax,bx
        mov     bl,byte ptr es:[di+320]
        add     ax,bx
        shr     ax,2
        jz      @lp2
        dec     al
@lp2:   mov     es:[di],al
        inc     di
        dec     cx
        jnz     @lp1
 end;

 procedure MCGAFadeUp(X,Y,X1,Y1: Word; ScrAddr: Pointer); assembler;
      asm
       les      di,[ScrAddr]
       mov      cx,[Y]
@Yloop:
       mov      ax,320
       mul      cx
       mov      bx,[X]
@Xloop:
       push     ax
       add      ax,bx
       mov      di,ax
       mov      si,ax
       xor      ah,ah
       xor      dx,dx
       mov      al,es:[si]
       add      dx,ax
       mov      al,es:[si+318]
       add      dx,ax
       mov      al,es:[si+640]
       add      dx,ax
       mov      al,es:[si+321]
       add      dx,ax
       shr      dx,2
       jz       @Skip
       dec      dl
@Skip: mov      [es:di],dl
       pop      ax
       inc      bx
       cmp      bx,[X1]
       jne      @Xloop
       inc      cx
       cmp      cx,[Y1]
       jne      @Yloop
 end;

 procedure MCGAWuLine(X0,Y0,X1,Y1: Integer; BaseCol,Levels,Intensity: Word); assembler;
      asm
        mov     ax,[X0]
        cmp     ax,0
        jge     @Next1
        xor     [X0],ax
@Next1: cmp     ax,319
        jle     @Next2
        mov     [X0],319
@Next2: mov     ax,[X1]
        cmp     ax,0
        jge     @Next3
        xor     [X1],ax
@Next3: cmp     ax,319
        jle     @Next4
        mov     [X1],319
@Next4: mov     ax,[Y0]
        cmp     ax,0
        jge     @Next5
        xor     [Y0],ax
@Next5: cmp     ax,199
        jle     @Next6
        mov     [Y0],199
@Next6: mov     ax,[Y1]
        cmp     ax,0
        jge     @Next7
        xor     [Y1],ax
@Next7: cmp     ax,199
        jle     @Next8
        mov     [Y1],199
@Next8: push    bp
        push    ds
        cld
        mov     si,[X0]
        mov     ax,[Y0]
        cmp     ax,[Y1]
        jna     @NoSwap
        xchg    [Y1],ax
        mov     [Y0],ax
        xchg    [X1],si
        mov     [X0],si
@NoSwap:
        mov     dx,SEGA000
        mov     ds,dx
        mov     dx,320
        mul     dx
        add     si,ax
        mov     al,byte ptr [BaseCol]
        mov     ds:[si],al
        mov     bx,1
        mov     cx,[X1]
        sub     cx,[X0]
        jns     @DeltaXSet
        neg     cx
        neg     bx
@DeltaXSet:
        mov     dx,[Y1]
        sub     dx,[Y0]
        jnz     @NoHoriz
        and     bx,bx
        jns     @DoHoriz
        std
@DoHoriz:
        lea     di,[bx+si]
        mov     ax,ds
        mov     es,ax
        mov     al,byte ptr [BaseCol]
        rep     stosb
        cld
        jnp     @Done
@NoHoriz:
        and     cx,cx
        jnz     @NoVert
        mov     al,byte ptr [BaseCol]
@VertLoop:
        and     si,320
        mov     ds:[si],al
        dec     dx
        jnz     @VertLoop
        jmp     @Done
@NoVert:
        cmp     cx,dx
        jnz     @NotDiag
        mov     al,byte ptr [BaseCol]
@DiagLoop:
        lea     si,[si+320+bx]
        mov     ds:[si],al
        dec     dx
        jnz     @DiagLoop
        jmp     @Done
@NotDiag:
        cmp     dx,cx
        jb      @XMajor
        xchg    dx,cx
        sub     ax,ax
        div     cx
        mov     di,cx
        sub     si,bx
        mov     dx,-1
        mov     cx,8
        sub     cx,[Intensity]
        mov     ch,byte ptr [Levels]
        dec     ch
        mov     bp,[BaseCol]
        xchg    bp,ax
@YMajorLoop:
        add     dx,bp
        jnc     @NoXAdvance
        add     si,bx
@NoXAdvance:
        add     si,320
        mov     ah,dh
        shr     ah,cl
        add     ah,al
        mov     ds:[si],ah
        mov     ah,dh
        shr     ah,cl
        xor     ah,ch
        add     ah,al
        mov     ds:[si+bx],ah
        dec     di
        jnz     @YMajorLoop
        jmp     @Done
@XMajor:
        sub     ax,ax
        div     cx
        mov     di,cx
        sub     si,320
        mov     dx,-1
        mov     cx,8
        sub     cx,[Intensity]
        mov     ch,byte ptr [Levels]
        dec     ch
        mov     bp,[BaseCol]
        xchg    bp,ax
@XMajorLoop:
        add     dx,bp
        jnc     @NoYAdvance
        add     si,320
@NoYAdvance:
        add     si,bx
        mov     ah,dh
        shr     ah,cl
        add     ah,al
        mov     ds:[si],ah
        mov     ah,dh
        shr     ah,cl
        xor     ah,ch
        add     ah,al
        mov     ds:[si+320],ah
        dec     di
        jnz     @XMajorLoop
@Done:  pop     ds
        pop     bp
 end;

 procedure SetLinecomp(Addr: Word); assembler;
      asm
        mov     dx,$3d4
        mov     al,$18
        mov     ah,[byte(Addr)]
        out     dx,ax
        mov     al,7
        out     dx,al
        inc     dx
        in      al,dx
        dec     dx
        mov     ah,[byte(Addr)+1]
        and     ah,00000001b
        shl     ah,4
        and     al,11101111b
        or      al,ah
        mov     ah,al
        mov     al,7
        out     dx,ax
        mov     al,9
        out     dx,al
        inc     dx
        in      al,dx
        dec     dx
        mov     ah,[byte(Addr)+1]
        and     ah,00000010b
        shl     ah,5
        and     al,10111111b
        or      al,ah
        mov     ah,al
        mov     al,9
        out     dx,ax
 end;

 procedure BaseVGA(ScrollX,ScrollY: Integer; Slide: Word); assembler;
      asm
        mov     ax,[ScrollY]
        mov     bx,320
        mul     bx
        add     ax,[ScrollX]
        mov     bx,[Slide]
        sub     bx,ax
        mov     dx,$3D4
        mov     al,13
        out     dx,al
        mov     ax,bx
        mov     cl,2
        shr     ax,cl
        and     ax,$FF
        inc     dx
        out     dx,ax
        dec     dx
        mov     al,12
        out     dx,al
        mov     ax,bx
        mov     cl,10
        shr     ax,cl
        inc     dx
        out     dx,ax
        mov     dx,$3DA
        in      al,dx
        mov     al,$20
        or      al,$13
        mov     dx,$3C0
        out     dx,al
        mov     ax,bx
        and     ax,3
        shl     ax,1
        out     dx,ax
end;

 procedure ScreenPan(Offs: Word); assembler;
      asm
        mov     bx,[Offs]
        mov     dx,$3d4
        mov     ah,bh
        mov     al,$0c
        out     dx,ax
        mov     ah,bl
        inc     al
        out     dx,ax
 end;

 procedure ConvertLine256to16M(const SrcAddr,DstAddr: Pointer; const Length: Word); assembler;
      asm
        les     di,DstAddr
        mov     ax,word ptr [SrcAddr+2]
        dw      $E88E   {<- mov gs,ax}
        mov     bx,word ptr [SrcAddr]
        mov     ax,[Length]
        add     ax,bx
        jnc     @Next
        call    far ptr NormalizeGSBX
@Next:  mov     ax,word [GfxPalAddr+2]
        dw      $E08E   {<- mov fs,ax}
        mov     si,word [GfxPalAddr]
        mov     cx,[Length]
@Loop:  db      $65
        mov     al,[bx]
        inc     bx
        xor     ah,ah
        push    si
        add     si,ax
        add     si,ax
        add     si,ax
        db      $66
        db      $64
        mov     ax,[si]
        db      $66    
        rol     ax,16
        stosb
        db      $66
        rol     ax,16
        xchg    al,ah
        stosw
        pop     si
        loop    @Loop
 end;

 procedure ConvertLine256to4G(const SrcAddr,DstAddr: Pointer; const Length: Word); assembler;
      asm
        les     di,DstAddr
        mov     ax,word ptr [SrcAddr+2]
        dw      $E88E   {<- mov gs,ax}
        mov     bx,word ptr [SrcAddr]
        mov     ax,[Length]
        add     ax,bx
        jnc     @Next
        call    far ptr NormalizeGSBX
@Next:  mov     ax,word [GfxPalAddr+2]
        dw      $E08E   {<- mov fs,ax}
        mov     si,word [GfxPalAddr]
        mov     cx,[Length]
@Loop:  db      $65
        mov     al,[bx]
        inc     bx
        xor     ah,ah
        push    si
        add     si,ax
        add     si,ax
        add     si,ax
        db      $66
        db      $64
        mov     ax,[si]
        db      $66
        rol     ax,16
        stosb
        db      $66
        rol     ax,16
        xchg    al,ah
        stosw
        stosb
        pop     si
        loop    @Loop
 end;

 procedure ConvertLine256to32K(const SrcAddr,DstAddr: Pointer; const Length: Word); assembler;
      asm
        les     di,DstAddr
        mov     ax,word ptr [SrcAddr+2]
        dw      $E88E   {<- mov gs,ax}
        mov     bx,word ptr [SrcAddr+0]
        mov     ax,[Length]
        add     ax,bx
        jnc     @Next
        call    far ptr NormalizeGSBX
@Next:  mov     cx,[Length]
        mov     ax,word [GfxPalAddr+2]
        dw      $E08E   {<- mov fs,ax}
        mov     si,word [GfxPalAddr]
@Loop:  push    cx
        db      $65
        mov     al,[bx]
        inc     bx
        xor     ah,ah
        push    si
        add     si,ax
        add     si,ax
        add     si,ax
        xor     dx,dx
        db      $64
        lodsb
        shr     al,3
        mov     cl,[mgRedPos]
        shl     ax,cl
        or      dx,ax
        db      $64
        lodsb
        mov     cl,[mgGreenAjast]
        shr     al,cl
        shl     ax,5
        or      dx,ax
        db      $64
        lodsb
        shr     al,3
        or      ax,dx
        stosw
        pop     si
        pop     cx
        loop    @Loop
 end;

 procedure ConvertLine16Mto32K(const SrcAddr,DstAddr: Pointer; const Length: Word); assembler;
      asm
        les     di,DstAddr
        mov     ax,word ptr [SrcAddr+2]
        dw      $E08E   {<- mov fs,ax}
        mov     si,word ptr [SrcAddr+0]
        mov     ax,[Length]
        add     ax,ax
        add     ax,[Length]
        add     ax,si
        jnc     @Next
        call    far ptr NormalizeFSSI
@Next:  mov     cx,[Length]
@Loop:  push    cx
        xor     ax,ax
        xor     dx,dx
        db      $64
        mov     al,[si]
        inc     si
        shr     al,3
        or      dx,ax
        db      $64
        mov     al,[si]
        inc     si
        mov     cl,[mgGreenAjast]
        shr     al,cl
        shl     ax,5
        or      dx,ax
        db      $64
        mov     al,[si]
        inc     si
        shr     al,3
        mov     cl,[mgRedPos]
        shl     ax,cl
        or      ax,dx
        stosw
        pop     cx
        loop    @Loop
 end;

 procedure ConvertLine16Mto4G(const SrcAddr,DstAddr: Pointer; const Length: Word); assembler;
      asm
        les     di,DstAddr
        mov     ax,word ptr [SrcAddr+2]
        dw      $E08E   {<- mov fs,ax}
        mov     si,word ptr [SrcAddr+0]
        mov     ax,[Length]
        add     ax,ax
        add     ax,[Length]
        add     ax,si
        jnc     @Next
        call    far ptr NormalizeFSSI
@Next:  mov     cx,[Length]
        xor     dx,dx
@Loop:  db      $64
        mov     ax,[si]
        add     si,2
        db      $64
        mov     dl,[si]
        inc     si
        stosw
        mov     es:[di],dx
        add     di,2
        loop    @Loop
 end;

 procedure PutSprite256to32K(X1,Y1,X2,Y2: Integer; DY: Boolean; Addr: Pointer);
 var SizeX: Word;
     i:     Integer;
 begin
  SizeX:=X2-X1+1;
  if DY then begin
   for i:=Y2 downto Y1 do begin
    ConvertLine256to32K(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX);
   end;
  end else begin
   for i:=Y1 to Y2 do begin
    ConvertLine256to32K(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX);
   end;
  end;
 end;

 procedure PutSprite256to16M(X1,Y1,X2,Y2: Integer; DY: Boolean; Addr: Pointer);
 var SizeX: Word;
     i:     Integer;
 begin
  SizeX:=X2-X1+1;
  if DY then begin
   for i:=Y2 downto Y1 do begin
    ConvertLine256to16M(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX);
   end;
  end else begin
   for i:=Y1 to Y2 do begin
    ConvertLine256to16M(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX);
   end;
  end;
 end;

 procedure PutSprite256to4G(X1,Y1,X2,Y2: Integer; DY: Boolean; Addr: Pointer);
 var SizeX: Word;
     i:     Integer;
 begin
  SizeX:=X2-X1+1;
  if DY then begin
   for i:=Y2 downto Y1 do begin
    ConvertLine256to4G(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX);
   end;
  end else begin
   for i:=Y1 to Y2 do begin
    ConvertLine256to4G(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX);
   end;
  end;
 end;

 procedure PutSprite16Mto32K(X1,Y1,X2,Y2: Integer; DY: Boolean; Addr: Pointer);
 var SizeX: Word;
     i:     Integer;
 begin
  SizeX:=X2-X1+1;
  if DY then begin
   for i:=Y2 downto Y1 do begin
    ConvertLine16Mto32K(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX+SizeX shl 1);
   end;
  end else begin
   for i:=Y1 to Y2 do begin
    ConvertLine16Mto32K(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX+SizeX shl 1);
   end;
  end;
 end;

 procedure PutSprite16Mto4G(X1,Y1,X2,Y2: Integer; DY: Boolean; Addr: Pointer);
 var SizeX: Word;
     i:     Integer;
 begin
  SizeX:=X2-X1+1;
  if DY then begin
   for i:=Y2 downto Y1 do begin
    ConvertLine16Mto4G(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX+SizeX shl 1);
   end;
  end else begin
   for i:=Y1 to Y2 do begin
    ConvertLine16Mto4G(Addr,mgBufferPtr,SizeX);
    PutLine(X1,X2,i,mgBufferPtr);
    IncPointer(Addr,SizeX+SizeX shl 1);
   end;
  end;
 end;

 {
 ----------------------------------------------------------------------------
  XorLine256Fast(X1,Y1,X2,Y2: Integer; Color: LongInt);
 ----------------------------------------------------------------------------
 }
 procedure XorLine256Fast(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Routine: Word;
     EIncr,NEIncr: Word;
     VertInc: LongInt;
      asm
        cld
        mov     si,[mgBytesPerLine]
        mov     word ptr [VertInc+2],0
        mov     ax,[X2]
        sub     ax,[X1]
        jns     @X2Greater
        neg     ax
        mov     bx,[X2]
        xchg    bx,[X1]
        mov     [X2],bx
        mov     bx,[Y2]
        xchg    bx,[Y1]
        mov     [Y2],bx
@X2Greater:
        mov     bx,[Y2]
        sub     bx,[Y1]
        jns     @Y2Greater
        neg     bx
        neg     si
        mov     word ptr [VertInc+2],$FFFF
@Y2Greater:
        mov     word ptr [VertInc],si
        mov     [Routine],offset @LoSlopeLine
        cmp     bx,ax
        jle     @LoSlope
        mov     [Routine],offset @HiSlopeLine
        xchg    bx,ax
@LoSlope:
        shl     bx,1
        mov     [EIncr],bx
        sub     bx,ax
        mov     di,bx
        sub     bx,ax
        mov     [NEIncr],bx
        push    ax
        mov     ax,[Y1]
        mul     [mgBytesPerLine]
        add     ax,[X1]
        adc     dx,word ptr [mgBankOffset]
        mov     es,SEGA000
        mov     bx,ax
        add     bx,[mgPixOffset]
        adc     dx,0
        pop     cx
        inc     cx
        jmp     [Routine]
@LoSlopeLine:
        mov     al,byte ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopLo:
        cmp     dl,dh
        je      @SetLo
        mov     dh,al
        xor     ax,ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     al,dh
        mov     dh,dl
@SetLo:
        xor     [es:bx],al
        add     bx,1
        adc     dl,0
        or      di,di
        jns     @LoPosDi
        add     di,[EIncr]
        loop    @LoopLo
        jmp     @Exit
@LoPosDi:
        add     di,[NEIncr]
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        loop    @LoopLo
        jmp     @Exit
@HiSlopeLine:
        mov     al,byte ptr [Color]
        mov     dh,byte ptr [mgCurbank]
@LoopHi:
        cmp     dh,dl
        je      @SetHi
        mov     dh,al
        xor     ax,ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     al,dh
        mov     dh,dl
@SetHi:
        xor     [es:bx],al
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        or      di,di
        jns     @HiPosDi
        add     di,[EIncr]
        loop    @LoopHi
        jmp     @Exit
@HiPosDi:
        add     di,[NEIncr]
        add     bx,1
        adc     dl,0
        loop    @LoopHi
@Exit:
 end;

 {
 ----------------------------------------------------------------------------
  OrLine256Fast(X1,Y1,X2,Y2: Integer; Color: LongInt);
 ----------------------------------------------------------------------------
 }
 procedure OrLine256Fast(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Routine: Word;
     EIncr,NEIncr: Word;
     VertInc: LongInt;
      asm
        cld
        mov     si,[mgBytesPerLine]
        mov     word ptr [VertInc+2],0
        mov     ax,[X2]
        sub     ax,[X1]
        jns     @X2Greater
        neg     ax
        mov     bx,[X2]
        xchg    bx,[X1]
        mov     [X2],bx
        mov     bx,[Y2]
        xchg    bx,[Y1]
        mov     [Y2],bx
@X2Greater:
        mov     bx,[Y2]
        sub     bx,[Y1]
        jns     @Y2Greater
        neg     bx
        neg     si
        mov     word ptr [VertInc+2],$FFFF
@Y2Greater:
        mov     word ptr [VertInc],si
        mov     [Routine],offset @LoSlopeLine
        cmp     bx,ax
        jle     @LoSlope
        mov     [Routine],offset @HiSlopeLine
        xchg    bx,ax
@LoSlope:
        shl     bx,1
        mov     [EIncr],bx
        sub     bx,ax
        mov     di,bx
        sub     bx,ax
        mov     [NEIncr],bx
        push    ax
        mov     ax,[Y1]
        mul     [mgBytesPerLine]
        add     ax,[X1]
        adc     dx,word ptr [mgBankOffset]
        mov     es,SEGA000
        mov     bx,ax
        add     bx,[mgPixOffset]
        adc     dx,0
        pop     cx
        inc     cx
        jmp     [Routine]
@LoSlopeLine:
        mov     al,byte ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopLo:
        cmp     dl,dh
        je      @SetLo
        mov     dh,al
        xor     ax,ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     al,dh
        mov     dh,dl
@SetLo:
        or      [es:bx],al
        add     bx,1
        adc     dl,0
        or      di,di
        jns     @LoPosDi
        add     di,[EIncr]
        loop    @LoopLo
        jmp     @Exit
@LoPosDi:
        add     di,[NEIncr]
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        loop    @LoopLo
        jmp     @Exit
@HiSlopeLine:
        mov     al,byte ptr [Color]
        mov     dh,byte ptr [mgCurbank]
@LoopHi:
        cmp     dh,dl
        je      @SetHi
        mov     dh,al
        xor     ax,ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     al,dh
        mov     dh,dl
@SetHi:
        or      [es:bx],al
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        or      di,di
        jns     @HiPosDi
        add     di,[EIncr]
        loop    @LoopHi
        jmp     @Exit
@HiPosDi:
        add     di,[NEIncr]
        add     bx,1
        adc     dl,0
        loop    @LoopHi
@Exit:
 end;

 {
 ----------------------------------------------------------------------------
  AndLine256Fast(X1,Y1,X2,Y2: Integer; Color: LongInt);
 ----------------------------------------------------------------------------
 }
 procedure AndLine256Fast(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Routine: Word;
     EIncr,NEIncr: Word;
     VertInc: LongInt;
      asm
        cld
        mov     si,[mgBytesPerLine]
        mov     word ptr [VertInc+2],0
        mov     ax,[X2]
        sub     ax,[X1]
        jns     @X2Greater
        neg     ax
        mov     bx,[X2]
        xchg    bx,[X1]
        mov     [X2],bx
        mov     bx,[Y2]
        xchg    bx,[Y1]
        mov     [Y2],bx
@X2Greater:
        mov     bx,[Y2]
        sub     bx,[Y1]
        jns     @Y2Greater
        neg     bx
        neg     si
        mov     word ptr [VertInc+2],$FFFF
@Y2Greater:
        mov     word ptr [VertInc],si
        mov     [Routine],offset @LoSlopeLine
        cmp     bx,ax
        jle     @LoSlope
        mov     [Routine],offset @HiSlopeLine
        xchg    bx,ax
@LoSlope:
        shl     bx,1
        mov     [EIncr],bx
        sub     bx,ax
        mov     di,bx
        sub     bx,ax
        mov     [NEIncr],bx
        push    ax
        mov     ax,[Y1]
        mul     [mgBytesPerLine]
        add     ax,[X1]
        adc     dx,word ptr [mgBankOffset]
        mov     es,SEGA000
        mov     bx,ax
        add     bx,[mgPixOffset]
        adc     dx,0
        pop     cx
        inc     cx
        jmp     [Routine]
@LoSlopeLine:
        mov     al,byte ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopLo:
        cmp     dl,dh
        je      @SetLo
        mov     dh,al
        xor     ax,ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     al,dh
        mov     dh,dl
@SetLo:
        and     [es:bx],al
        add     bx,1
        adc     dl,0
        or      di,di
        jns     @LoPosDi
        add     di,[EIncr]
        loop    @LoopLo
        jmp     @Exit
@LoPosDi:
        add     di,[NEIncr]
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        loop    @LoopLo
        jmp     @Exit
@HiSlopeLine:
        mov     al,byte ptr [Color]
        mov     dh,byte ptr [mgCurbank]
@LoopHi:
        cmp     dh,dl
        je      @SetHi
        mov     dh,al
        xor     ax,ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     al,dh
        mov     dh,dl
@SetHi:
        and     [es:bx],al
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        or      di,di
        jns     @HiPosDi
        add     di,[EIncr]
        loop    @LoopHi
        jmp     @Exit
@HiPosDi:
        add     di,[NEIncr]
        add     bx,1
        adc     dl,0
        loop    @LoopHi
@Exit:
 end;

 procedure PAL6to8(Addr: Pointer);
 var i: Word;
 begin
  for i:=0 to 767 do xPutByte(Addr,i,xGetByte(Addr,i) shl 2);
 end;

 procedure PAL8to6(Addr: Pointer);
 var i: Word;
 begin
  for i:=0 to 767 do xPutByte(Addr,i,xGetByte(Addr,i) shr 2);
 end;

 procedure SetStandardPal;
 var i: Word;
 begin
  for i:=0 to 255 do
   SetVGAPal(i,VGAPal8[i*3] shr 2,VGAPal8[i*3+1] shr 2,VGAPal8[i*3+2] shr 2);
 end;

 end.