{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(* ADVANCED MEMORY UNIT/I80386 AND HIGHER, REAL MODE, PROTECTED MODE       *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit MemPlus;

 interface

{COMMON}
 function  GetPtr (Addr: Pointer; Offs:LongInt): Pointer;

 procedure IncPointer (var Addr: Pointer; Offs: LongInt);
  inline ($5B/                    { pop bx }
          $58/                    { pop ax }
          $5F/                    { pop di }
          $07/                    { pop es }
          $26/$01/$1D/            { add word ptr es:[di],bx }
          $15/$00/$00/            { adc ax,0000 }
          $74/$08/                { jz +08      }
          $F7/$26/SelectorInc/    { mul word ptr [SelectorInc] }
          $26/$01/$45/$02);       { add es:[di+02],ax }

 procedure IncPtr (var Addr: Pointer);
  inline ($5F/                    { pop di }
          $07/                    { pop es }
          $8C/$C0/                { mov ax,es }
          $26/$FF/$05/            { inc word ptr es:[di] }
          $75/$07/                { jnz + $07 }
          $A1/SelectorInc/        { mov ax,[SelectorInc] }
          $26/$01/$45/$02);       { add es:[di+02],ax     }

 procedure DecPointer (var Addr: Pointer; Offs: LongInt);
  inline ($5B/                    { pop bx }
          $58/                    { pop ax }
          $5F/                    { pop di }
          $07/                    { pop es }
          $26/$29/$1D/            { sub word ptr [di],bx }
          $1D/$00/$00/            { sbb ax,0000 }
          $74/$08/                { jz  +08      }
          $F7/$26/SelectorInc/    { mul word ptr [SelectorInc] }
          $26/$29/$45/$02);       { sub es:[di+02],ax }

 procedure DecPtr (var Addr: Pointer);
  inline ($5F/                    { pop di }
          $07/                    { pop es }
          $8C/$C0/                { mov ax,es }
          $26/$FF/$0D/            { dec word ptr es:[di] }
          $75/$07/                { jnz + $07 }
          $A1/SelectorInc/        { mov ax,[SelectorInc] }
          $26/$29/$45/$02);       { sub es:[di+02],ax     }

 function  GetByte (Addr: Pointer): Byte;
  inline  ($5F/                   { pop di }
           $07/                   { pop es }
           $26/$8A/$05);          { mov al,es:[di] }

 function  GetWord (Addr: Pointer): Word;
  inline ($5F/                    { pop di }
          $07/                    { pop es }
          $26/$8A/$05/            { mov al,es:[di] }
          $47/                    { inc di }
          $75/$08/                { jnz +08 }
          $8C/$C3/                { mov bx,es }
          $03/$1E/SelectorInc/    { add bx,[SelectorInc] }
          $8E/$C3/                { mov es,bx }
          $26/$8A/$25);           { mov ah,es:[di] }

 procedure PutByte (Addr: Pointer; Value: Byte);
  inline  ($58/                   { pop ax }
           $5F/                   { pop di }
           $07/                   { pop es }
           $26/$88/$05);          { mov [es:di],al   }

 procedure PutWord (Addr: Pointer; Value: Word);
  inline ($58/                    { pop ax }
          $5F/                    { pop di }
          $07/                    { pop es }
          $26/$88/$05/            { mov [es:di],al }
          $47/                    { inc di }
          $75/$08/                { jnz +08 }
          $8C/$C3/                { mov bx,es }
          $03/$1E/SelectorInc/    { add bx,[SelectorInc] }
          $8E/$C3/                { mov es,bx }
          $26/$88/$25);           { mov ah,es:[di] }

 function  xGetByte (Addr: Pointer; Offs: LongInt): Byte;
  inline ($5E/                    { pop si }
          $58/                    { pop ax }
          $5F/                    { pop di }
          $5B/                    { pop bx }
          $03/$FE/                { add di,si }
          $15/$00/$00/            { adc ax,0000 }
          $74/$06/                { jz +06 }
          $F7/$26/SelectorInc/    { mul word [SelectorInc] }
          $03/$D8/                { add bx,ax }
          $8E/$C3/                { mov es,bx }
          $26/$8A/$05);           { mov al,es:[di] }

 function  xGetWord (Addr: Pointer; Offs: LongInt): Word;
  inline ($5E/                    { pop si }
          $58/                    { pop ax }
          $5F/                    { pop di }
          $5B/                    { pop bx }
          $03/$FE/                { add di,si }
          $15/$00/$00/            { adc ax,0000 }
          $74/$06/                { jz +06 }
          $F7/$26/SelectorInc/    { mul word [SelectorInc] }
          $03/$D8/                { add bx,ax }
          $8E/$C3/                { mov es,bx }
          $26/$8A/$05/            { mov al,es:[di] }
          $47/                    { inc di }
          $75/$08/                { jnz +08 }
          $8C/$C3/                { mov bx,es }
          $03/$1E/SelectorInc/    { add bx,[SelectorInc] }
          $8E/$C3/                { mov es,bx }
          $26/$8A/$25);           { mov ah,es:[di] }

 procedure xPutByte (Addr: Pointer; Offs: LongInt; Value: Byte);
  inline ($59/                    { pop cx }
          $5E/                    { pop si }
          $58/                    { pop ax }
          $5F/                    { pop di }
          $5B/                    { pop bx }
          $03/$FE/                { add di,si }
          $15/$00/$00/            { adc ax,0000 }
          $74/$06/                { jz +06 }
          $F7/$26/SelectorInc/    { mul word [SelectorInc] }
          $03/$D8/                { add bx,ax }
          $8E/$C3/                { mov es,bx }
          $26/$88/$0D);           { mov es:[di],cl }

 procedure xPutWord (Addr: Pointer; Offs: LongInt; Value: Word);
  inline ($59/                    { pop cx }
          $5E/                    { pop si }
          $58/                    { pop ax }
          $5F/                    { pop di }
          $5B/                    { pop bx }
          $03/$FE/                { add di,si }
          $15/$00/$00/            { adc ax,0000 }
          $74/$06/                { jz +06 }
          $F7/$26/SelectorInc/    { mul word [SelectorInc] }
          $03/$D8/                { add bx,ax }
          $8E/$C3/                { mov es,bx }
          $26/$88/$0D/            { mov es:[di],cl }
          $47/                    { inc di }
          $75/$08/                { jnz +08 }
          $8C/$C3/                { mov bx,es }
          $03/$1E/SelectorInc/    { add bx,[SelectorInc] }
          $8E/$C3/                { mov es,bx }
          $26/$88/$2D);           { mov es:[di],ch }

 function  GetStr (Addr: Pointer; Len: Byte): String;
 function  xGetStr (Addr: Pointer; Offset: LongInt; Len: Byte): String;
 procedure PutStr (Addr: Pointer; Str: String);
 procedure xPutStr (Addr: Pointer; Offset: LongInt; Str: String);
 procedure xMove (Addr1, Addr2: Pointer; Len: LongInt);
 procedure xFill (Addr1: Pointer; Count: LongInt; Value: Byte);
 procedure GetBuffer (var Buffer: Pointer; BufferLength: LongInt);
 procedure FreeBuffer (var Buffer: Pointer; BufferLength: LongInt);
 function  GetAbsoluteAddress (Addr: Pointer): LongInt;
 function  LoadFile (const FileName: String): Pointer;
 procedure SaveFile (const FileName: String; Buffer :Pointer; Size: LongInt);
 function  Normalize (Addr: Pointer): Pointer;
 function  GetPointer (Address: Longint): Pointer;

{$IFDEF DPMI}
 function  xGlobalDosAlloc (var Addr: Pointer; Size: LongInt): Word;
 procedure xGlobalDosFree (var Addr: Pointer);
{$ENDIF}

 implementation

{$IFDEF MSDOS}
 uses Version,i80386;
{$ELSE}
 uses Version,i80386,WinApi;
{$ENDIF}

 function GetPtr(Addr: Pointer; Offs:LongInt): Pointer;
{$IFDEF DPMI}
 begin
  GetPtr:=Ptr(LongAdd(TLong(Addr).Hi,LongMul(TLong(Offs).Hi,SelectorInc)),
              LongAdd(TLong(Addr).Lo,TLong(Offs).Lo));
{$ELSE}
 var Dummy: Pointer;
 begin
  Dummy:=Addr;
  if Offs>0 then
   IncPointer(Dummy,Offs)
  else
   DecPointer(Dummy,Abs(Offs));
  GetPtr:=Normalize(Dummy);
{$ENDIF}
 end;

 function GetStr(Addr: Pointer; Len: Byte): String;
 var S: String;
     i: Byte;
 begin
  S:='';
  for i:=1 to Len do begin
   S:=S+Chr(Byte(Addr^));
   IncPtr(Addr);
  end;
  GetStr:=S;
 end;

 function xGetStr(Addr: Pointer; Offset: LongInt; Len: Byte): String;
 var S: String;
     i: Byte;
 begin
  S:='';
  IncPointer(Addr,Offset);
  for i:=1 to Len do begin
   S:=S+Chr(Byte(Addr^));
   IncPtr(Addr);
  end;
  xGetStr:=S;
 end;

 procedure PutStr(Addr: Pointer; Str: String);
 var i: Byte;
 begin
  for i:=1 to Length(Str) do begin
   PutByte(Addr,Byte(Str[i]));
   IncPtr(Addr);
  end;
 end;

 procedure xPutStr(Addr: Pointer; Offset: LongInt; Str: String);
 var i: Byte;
 begin
  IncPointer(Addr,Offset);
  for i:=1 to Length(Str) do begin
   PutByte(Addr,Byte(Str[i]));
   IncPtr(Addr);
  end;
 end;

 function Normalize(Addr: Pointer): Pointer; assembler;
      asm
{$IFDEF MSDOS}
        mov     ax,TLong(Addr).Lo
        mov     dx,TLong(Addr).Hi
        cmp     ax,$000F
        jna     @Quit
        mov     bx,ax
        and     ax,$000F
        and     bx,$FFF0
        shr     bx,4
        add     dx,bx
@Quit:
{$ELSE}
        mov     ax,$0006
        mov     bx,word ptr [Addr+2]
        int     $31
        add     dx,word ptr [Addr+0]
        adc     cx,0
        mov     ax,$0007
        mov     bx,[NormalSel]
        int     $31
        mov     dx,[NormalSel]
        xor     ax,ax
{$ENDIF}
 end;

 procedure xMove(Addr1, Addr2: Pointer; Len: LongInt); assembler;
      asm
{$IFDEF DPMI}
        les     di,Addr2
        mov     ax,TLong(Addr1).Hi
        dw      $E08E   {<- mov fs,ax}
        mov     si,TLong(Addr1).Lo
        mov     cx,TLong(Len).Hi
        xor     cx,0
        jz      @Next
@Loop1: push    cx
        xor     cx,cx
@Loop2: db      $64    {䨪 樨 c fs}
        mov     al,[si]
        inc     si
        jnz     @Cont1
        dw      $E38C   {<- mov bx,fs}
        add     bx,SelectorInc
        dw      $E38E   {<- mov fs,bx}
@Cont1: mov     es:[di],al
        inc     di
        jnz     @Cont2
        mov     bx,es
        add     bx,SelectorInc
        mov     es,bx
@Cont2: loop    @Loop2
        pop     cx
        loop    @Loop1
@Next:  mov     cx,TLong(Len).Lo
        xor     cx,0
        jz      @End
@Loop3: db      $64
        mov     al,[si]
        inc     si
        jnz     @Cont3
        dw      $E38C   {<- mov bx,fs}
        add     bx,SelectorInc
        dw      $E38E   {<- mov fs,bx}
@Cont3: mov     es:[di],al
        inc     di
        jnz     @Cont4
        mov     bx,es
        add     bx,SelectorInc
        mov     es,bx
@Cont4: loop    @Loop3
@End:
{$ELSE}
        push    ds
        les     di,Addr2
        lds     si,Addr1
        mov     cx,TLong(Len).Hi
        xor     cx,0
        jz      @Next
@Loop1: push    cx
        xor     cx,cx
@Loop2: mov     al,ds:[si]
        inc     si
        jnz     @Cont1
        mov     bx,ds
        add     bx,SelectorInc
        mov     ds,bx
@Cont1: mov     es:[di],al
        inc     di
        jnz     @Cont2
        mov     bx,es
        add     bx,SelectorInc
        mov     es,bx
@Cont2: loop    @Loop2
        pop     cx
        loop    @Loop1
@Next:  mov     cx,TLong(Len).Lo
        xor     cx,0
        jz      @End
@Loop3: mov     al,ds:[si]
        inc     si
        jnz     @Cont3
        mov     bx,ds
        add     bx,SelectorInc
        mov     ds,bx
@Cont3: mov     es:[di],al
        inc     di
        jnz     @Cont4
        mov     bx,es
        add     bx,SelectorInc
        mov     es,bx
@Cont4: loop    @Loop3
@End:   pop     ds
{$ENDIF}
 end;

 procedure xFill(Addr1: Pointer; Count: LongInt; Value: Byte); assembler;
      asm
{$IFDEF DPMI}
        les     di,Addr1
        mov     al,[Value]
        mov     cx,TLong(Count).Hi
        xor     cx,0
        jz      @Next
@Loop1: push    cx
        xor     cx,cx
@Loop2: mov     es:[di],al
        inc     di
        jnz     @Cont2
        mov     bx,es
        add     bx,SelectorInc
        mov     es,bx
@Cont2: loop    @Loop2
        pop     cx
        loop    @Loop1
@Next:  mov     cx,TLong(Count).Lo
        xor     cx,0
        jz      @End
@Loop3: mov     es:[di],al
        inc     di
        jnz     @Cont4
        mov     bx,es
        add     bx,SelectorInc
        mov     es,bx
@Cont4: loop    @Loop3
@End:
{$ELSE}
        les     di,Addr1
        mov     al,[Value]
        mov     cx,TLong(Count).Hi
        xor     cx,0
        jz      @Next
@Loop1: push    cx
        xor     cx,cx
@Loop2: mov     es:[di],al
        inc     di
        jnz     @Cont2
        mov     bx,es
        add     bx,SelectorInc
        mov     es,bx
@Cont2: loop    @Loop2
        pop     cx
        loop    @Loop1
@Next:  mov     cx,TLong(Count).Lo
        xor     cx,0
        jz      @End
@Loop3: mov     es:[di],al
        inc     di
        jnz     @Cont4
        mov     bx,es
        add     bx,SelectorInc
        mov     es,bx
@Cont4: loop    @Loop3
@End:
{$ENDIF}
 end;

{$IFDEF DPMI}
 procedure GetBuffer (var Buffer: Pointer; BufferLength: LongInt);
 begin
  Buffer:=GlobalAllocPtr(gmem_Moveable,BufferLength);
 end;

 procedure FreeBuffer(var Buffer: Pointer; BufferLength: LongInt);
 begin
  GlobalFreePtr(Buffer);
 end;
{$ELSE}

 procedure GetBuffer(var Buffer: Pointer; BufferLength: LongInt);
 var Dummy:pointer;
 begin
  if BufferLength<0 then begin
   Buffer:=nil; Exit;
  end;
  if MaxAvail<BufferLength then begin
   Buffer:=nil; Exit;
  end;
  if BufferLength<$FFFF then GetMem(Buffer, BufferLength)
  else begin
   GetMem(Buffer,$FFFF);
   BufferLength:=BufferLength-$FFFF;
   while BufferLength>$FFFF do begin
    GetMem(Dummy,$FFFF);
    BufferLength:=BufferLength-$FFFF;
   end;
   GetMem(Dummy, BufferLength);
  end;
 end;

 procedure FreeBuffer(var Buffer: Pointer; BufferLength: LongInt);
 var Dummy:pointer;
     LeftToFree: LongInt;
 begin
  if BufferLength<$FFFF then FreeMem(Buffer, BufferLength)
  else begin
   Dummy:=Buffer;
   LeftToFree:=BufferLength;
   FreeMem(Buffer,$FFFF);
   LeftToFree:=LeftToFree-$FFFF;
   Dummy:=Ptr(Seg(Dummy^)+$1000,Ofs(Dummy^));
   while LeftToFree>$FFFF do begin
    FreeMem(Dummy,$FFFF);
    LeftToFree:=LeftToFree-$FFFF;
    Dummy:=Ptr(Seg(Dummy^)+$1000,Ofs(Dummy^));
   end;
   FreeMem(Dummy,LeftToFree);
  end;
 end;
{$ENDIF}

 function  GetAbsoluteAddress(Addr: Pointer): LongInt;
 begin
{$IFDEF MSDOS}
  GetAbsoluteAddress:=LongAdd(LongShl(Seg(Addr^),4),Ofs(Addr^));
{$ELSE}
  GetAbsoluteAddress:=LongAdd(GetSelectorBase(Seg(Addr^)),Ofs(Addr^));
{$ENDIF}
 end;

 function  LoadFile(const FileName: string): Pointer;
 var Buffer: Pointer;
     Size, Offset, Count: LongInt;
     F: file;
 begin
  Buffer:=nil;
  Assign(F,FileName);
  Reset(F,1);
{$i+}
  if IOResult<>0 then begin
   LoadFile:=nil;
   exit;
  end;
{$i-}
  Size:=FileSize(F);
  GetBuffer(Buffer,Size);
  if Buffer<>nil then begin
   Offset:=0;
   while Offset<Size do begin
    Count:=Size-Offset;
    if Count>2048 then Count:=2048;
    BlockRead(F,GetPtr(Buffer,Offset)^,Count);
    Offset:=LongAdd(Offset,Count);
   end;
  end;
  Close(F);
{$i+}
  if IOResult<>0 then begin
   FreeBuffer(Buffer,Size); Buffer:=nil;
  end;
{$i-}
  LoadFile:= Buffer;
 end;

 procedure SaveFile(const FileName: String; Buffer :Pointer; Size: LongInt);
 var Offset, Count: LongInt;
     F: file;
 begin
  Assign(F,FileName);
  Rewrite(F,1);
  Offset:=0;
  while Offset<Size do begin
   Count:=Size-Offset;
   if Count>2048 then Count:=2048;
   BlockWrite(F, GetPtr(Buffer,Offset)^,Count);
   Offset:=LongAdd(Offset,Count);
  end;
  Close(F);
 end;

 function GetPointer(Address: Longint): Pointer;
 begin
{$IFDEF MSDOS}
  GetPointer:=ptr(LongShr(Address,$04),LongAnd(Address,$0F));
{$ELSE}
  if SetSelectorBase(NormalSel,LongAdd(LongShl(TLong(Address).Hi,4),
     TLong(Address).Lo))>0 then GetPointer:=Ptr(NormalSel,0)
  else GetPointer:=nil;
{$ENDIF}
 end;

{$IFDEF DPMI}
 function xGlobalDosAlloc(var Addr: Pointer; Size: LongInt): Word;
 var Long: LongInt;
 begin
  Long:=GlobalDosAlloc(Size);
  Addr:=Ptr(TLong(Long).Lo,0);
  xGlobalDosAlloc:=TLong(Long).Hi;
 end;

 procedure xGlobalDosFree(var Addr: Pointer);
 begin
  GlobalDosFree(Seg(Addr^));
 end;
{$ENDIF}

 end.