{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(* FAST SIN/COS CALCULATION /I80386 AND HIGHER, REAL MODE, PROTECTED MODE  *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit SinCos;

 interface

 function xSin (Arg: Integer): Real;
 function xCos (Arg: Integer): Real;
 function xTan (Arg: Integer): Real;
 function xCtg (Arg: Integer): Real;

 implementation

 uses Version;

 var i,Correct: Real;
     SinTable: array [0..180] of Real;
     CosTable: array [0..180] of Real;

 function xSin(Arg: Integer): Real;
 var a: Integer;
 begin
  a:=Arg mod 360;
  if a>180 then a:=a-360;
  if a<-180 then a:=a+360;
  if a<0 then xSin:=SinTable[Abs(a)]*(-1) else xSin:=SinTable[a];
 end;

 function xCos(Arg: Integer): Real;
 var a: Integer;
 begin
  a:=Arg mod 360;
  if a>180 then a:=a-360;
  if a<-180 then a:=a+360;
  xCos:=CosTable[Abs(a)];
 end;

 function xTan(Arg: Integer): Real;
 begin
  xTan:=xSin(Arg)/xCos(Arg);
 end;

 function xCtg(Arg: Integer): Real;
 begin
  xCtg:=xCos(Arg)/xSin(Arg);
 end;

 begin
  Correct:=Pi/180;
  i:=0;
  repeat
   SinTable[trunc(i)]:=Sin(i*Correct);
   CosTable[trunc(i)]:=Cos(i*Correct);
   i:=i+1;
  until i>180;
 end.


