{$g+,n-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*               256-COLORED VGA IMAGE (VIM) COMPRESS UTILITY              *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}


program COMPVIM;

uses DOSUtil,MemPlus,MegaGraf,i80386;
var
 ImagePtr,p,p1:                   Pointer;
 j,dx,dy,Pal,k:                   Word;
 a,c,v:                           Byte;
 Name,Header,NameS:               String;
 Nbytes,FileLen,i,MaxValue:       LongInt;
 f:                               File;
 CompBlk: array [0..2] of         Byte;
 CompressTable: array [0..255] of LongInt;

function LeadingZero (w: Byte): String;
var S: String;
begin
 Str(w:0,S);
 if Length(s)=1 then S:='00'+S;
 if Length(s)=2 then S:='0'+S;
 LeadingZero:=S;
end;

begin
 Write('256-colored VGA Image (VIM) Compress Utility v2.0');
{$IFDEF DPMI}
 Writeln(' // Protected Mode');
{$ELSE}
 Writeln(' // Real Mode');
{$ENDIF}
 Writeln('Copyright (c) 1996-98 by Vadim Bodrov (falkoris@hotmail.com)');
 Writeln('This program is a part of PLUS SYSTEM PRO 2.0 GDK FOR BORLAND PASCAL');
 if ParamCount<2 then begin
  Writeln('Usage: COMPVIM [[drive:][path]source.vim dest.vim]');
  Halt(0);
 end;
 Name:=ParamStr(1);
 NameS:=ParamStr(2);
 Nbytes:=SizeOfFile(Name);
 if MaxAvail<Nbytes then begin
  Writeln('Not enough memory');
  Halt(0);
 end;
 GetBuffer(p,Nbytes);
 ReadFromFile(Name,P,0,NBytes);
 p1:=p;
 if not GetVIMWH(dx,dy,p) then begin
  Writeln(name,' is not VIM format file!');
  Halt(0);
 end;
 ImagePtr:=p;
 Pal:=xGetWord(p,5);
 FileLen:=LongMul(dx,dy);
 IncPointer(ImagePtr,5+Pal*3);
 if (xGetByte(p1,3) and 1)=1 then begin
  Writeln(Name,' already compressed');
  Halt(0);
 end;
 c:=0;
 FillChar(CompressTable,SizeOf(CompressTable),0);
 p:=ImagePtr;
 for i:=0 to FileLen-1 do begin
  a:=Byte(P^);
  IncPtr(P);
  Inc(CompressTable[a]);
 end;
 MaxValue:=MaxLongInt;
 for i:=0 to 255 do begin
  if CompressTable[i]<MaxValue then begin
   MaxValue:=CompressTable[i];
   a:=i;
  end;
 end;
 Assign(f,NameS);
 ReWrite(f,1);
 IncPointer(p1,4);
 Header:='VIM'+chr(1)+char(p1^)+chr(a);
 BlockWrite(f,Header[1],6);
 IncPtr(p1);
 BlockWrite(f,p1^,(6+pal*3));
 ImagePtr:=GetPtr(p1,6+pal*3);
 p:=ImagePtr;
 i:=0;
 CompBlk[0]:=A;
 Write('Compression process: 000%');
 HideCursor;
 repeat
  j:=0;
  p1:=ImagePtr;
  c:=Byte(p1^);
  repeat
   IncPtr(p1);
   Inc(j);
   v:=Byte(p1^);
  until (j=255) or (c<>v) or ((i+j)=FileLen);
  if (j>4) or (c=a) then begin
   CompBlk[1]:=j;
   CompBlk[2]:=c;
   BlockWrite(f,CompBlk[0],3);
  end else BlockWrite(f,ImagePtr^,j);
  IncPointer(ImagePtr,j);
  Inc(i,j);
  Write(chr(8),chr(8),chr(8),chr(8),LeadingZero(LongDiv(LongMul(100,i),FileLen)),'%');
 until (i=FileLen);
 Close(f);
 ShowCursor;
 Writeln(' (',trunc(100*SizeOfFile(NameS)/Nbytes),'%)');
end.
