{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*                         TARGA TO VIM CONVERTOR                          *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

 uses i80386,MemPlus,DosUtil;

 var Name:     String;
     MainName: String;
     f1,f2:    File;
     VIMID:    String[3];
     i,j:      Word;
     bTemp:    Byte;
     wTemp:    Word;
     FID:      String;
     Compress: Byte;
     CompByte: Byte;
     RepByte:  Byte;
     palStart: Word;
     palNum:   Word;
     DX,DY:    Word;
     VIMpal:   array [0..767] of Byte;
     LineBuf:  Pointer;
     L,E:      LongInt;
     Convert:  Boolean;
     HaveText: Boolean;

 procedure SUpCase(var S: String);
 begin
  for i:=1 to Length(S) do S[i]:=UpCase(S[i]);
 end;

 procedure Quit(S: String);
 begin
{$F-}
  Close(f1);
  Close(f2);
{$F+}
  if (S=' Ok!') and (IOResult<>0) then Writeln(' Disk IO Error!')
  else Writeln(S);
  Writeln;
  Halt(0);
 end;

 procedure Conv64K(DX: Word; P: Pointer);
 var k:  Word;
     cv: Word;
 begin
  { 64K to 32K }
  if Convert then begin
   for k:=0 to DX-1 do begin
    cv:=xGetWord(P,k*2);
    cv:=((cv and $FFE0) shr 1) or (cv and $1F);
    xPutWord(P,k*2,cv);
   end;
  end;
 end;

begin
  Write('VIM (pallette and RGB colored) to Uncompressed TARGA Convertor');
{$IFDEF DPMI}
  Writeln(' // Protected Mode');
{$ELSE}
  Writeln(' // Real Mode');
{$ENDIF}
  Writeln('Copyright (c) 1996-98 by Vadim Bodrov (falkoris@hotmail.com)');
  Writeln('This program is a part of PLUS SYSTEM PRO 2.0 GDK FOR BORLAND PASCAL');
  Writeln('Usage:  VIM2TGA.EXE [/c] filename.VIM [/s TEXT]');
  Writeln('        [/s TEXT] - include any image identification field TEXT.');
  Writeln('        [/c]      - convert VIM 64K to TARGA 32K (HiColor only)');
  Writeln;
  if ParamCount=0 then exit;
  for i:=1 to ParamCount do begin
   if (ParamStr(i)='/c') or (ParamStr(i)='/C') then Convert:=true;
   if (ParamStr(i)='/s') or (ParamStr(i)='/S') then HaveText:=true;
   if (Copy(ParamStr(i),1,1)<>'/') and (not HaveText) then Name:=ParamStr(i);
  end;
  SUpCase(Name);
  if (Length(Name)<=4) or (Copy(Name,Length(Name)-3,1)<>'.') then
  Name:=Name+'.VIM';
  MainName:=Copy(Name,1,Length(Name)-4);
{$i-}
  Assign(f1,Name);
  Reset(f1,1);
{$i+}
  if IOResult<>0 then Quit('Can`t open file '+Name);
{$i-}
  Assign(f2,MainName+'.TGA');
  ReWrite(f2,1);
{$i+}
  if IOResult<>0 then Quit('Can`t open file '+MainName+'.TGA');
  VIMID:='VIM';
{$i-}
  BlockRead(f1,VIMID[1],3);
  if VIMID<>'VIM' then Quit('It`s not a VIM file!');
  FID:='';
  if (ParamCount>1) then begin
   i:=1;
   repeat
    inc(i);
    if (ParamStr(i)='/s') or (ParamStr(i)='/S') then begin
     for j:=i+1 to ParamCount do FID:=FID+ParamStr(j)+' ';
     i:=j;
    end;
   until (i=ParamCount) or (Copy(ParamStr(i),1,1)='/');
  end;
  BlockWrite(f2,FID[0],1);
  BlockRead(f1,Compress,1);
  case (Compress shr 5) of
   0: wTemp:=$0101;
   1: wTemp:=$0200;
   3: wTemp:=$0300;
   4: wTemp:=$0400;
  end;
  BlockWrite(f2,wTemp,2);
  BlockRead(f1,bTemp,1);
  palStart:=Word(bTemp);
  if ((Compress and 1)=1) and (Compress>1) then Quit(' Unknown file format...');
  if (Compress and 1)=1 then BlockRead(f1,CompByte,1);
  BlockRead(f1,palNum,2);
  BlockRead(f1,VIMpal[0],palNum*3);
  BlockRead(f1,DX,2);
  BlockRead(f1,DY,2);
  BlockWrite(f2,palStart,2);
  BlockWrite(f2,palNum,2);
  if (Compress shr 5)=0 then bTemp:=24 else bTemp:=0;
  BlockWrite(f2,bTemp,1);
  wTemp:=0;
  BlockWrite(f2,wTemp,2);
  BlockWrite(f2,wTemp,2);
  BlockWrite(f2,DX,2);
  BlockWrite(f2,DY,2);
  bTemp:=((Compress shr 5)+1)*8;
  BlockWrite(f2,bTemp,1);
  bTemp:=36;
  BlockWrite(f2,bTemp,1);
  if Length(FID)>0 then BlockWrite(f2,FID[1],Byte(FID[0]));
  if PalNum>0 then begin
   for i:=0 to palNum-1 do begin
    bTemp:=VIMPal[i*3+2] shl 2;
    BlockWrite(f2,bTemp,1);
    bTemp:=VIMPal[i*3+1] shl 2;
    BlockWrite(f2,bTemp,1);
    bTemp:=VIMPal[i*3] shl 2;
    BlockWrite(f2,bTemp,1);
   end;
  end;
  GetBuffer(LineBuf,LongMul(Word(DX),(Compress shr 5)+1));
  if (Compress and 1)=0 then begin
   L:=0;
   E:=LongMul(LongInt(DX)*LongInt(DY),(Compress shr 5)+1);
   repeat
    BlockRead(f1,LineBuf^,LongMul(Word(DX),(Compress shr 5)+1));
    if (Compress shr 5)=1 then Conv64K(DX,LineBuf);
    BlockWrite(f2,LineBuf^,LongMul(Word(DX),(Compress shr 5)+1));
    L:=L+LongMul(Word(DX),(Compress shr 5)+1);
   until L=E;
  end else begin
   L:=0;
   E:=LongMul(DX,DY);
   repeat;
    BlockRead(f1,bTemp,1);
    if bTemp<>CompByte then begin
     BlockWrite(f2,bTemp,1);
     inc(L);
    end else begin
     BlockRead(f1,RepByte,1);
     BlockRead(f1,bTemp,1);
     for i:=1 to RepByte do begin
      BlockWrite(f2,bTemp,1);
      inc(L);
     end;
    end;
   until L=E;
  end;
  FreeBuffer(LineBuf,LongMul(Word(DX),(Compress shr 5)+1));
  Close(f1);
  Close(f2);
{$i+}
  if IOResult=0 then begin
   Writeln('Output TARGA file info:');
   Writeln('File Name    - ',MainName+'.tga');
   Writeln('File Size    - ',SizeOfFile(MainName+'.tga'));
   Writeln('Color Depth  - ',((Compress shr 5)+1)*8,' bpp');
   Writeln('Image Lenght - ',Dx);
   Writeln('Image Width  - ',Dy);
   Writeln('Origin       - upper left-hand corner');
  end else Writeln('Can`t create file...');
end.



