{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*                     VGA IMAGE (VIM) VIEWER UTILITY                      *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

uses MemPlus,MegaGraf,DOSUtil,Keyboard,i80386;

var Name,Ext,Main:     String;
    P,P1:              Pointer;
    N:                 LongInt;
    pl,PalFlag:        Boolean;
    Dx,Dy,Pal,Dtep,Np: Word;
    X,Y:               Integer;
    XRes,YRes:         Word;
    grMode:            Byte;
    Step:              Byte;
    Show:              Boolean;

begin
 pl:=false;
 Write('VGA IMAGE (VIM) VIEWER v2.1');
{$IFDEF DPMI}
 Writeln(' // Protected Mode');
{$ELSE}
 Writeln(' // Real Mode');
{$ENDIF}
 Writeln('Copyright (c) 1996-98 by Vadim Bodrov (falkoris@hotmail.com)');
 Writeln('This program is a part of PLUS SYSTEM PRO 2.0 GDK FOR BORLAND PASCAL');
 Writeln('Usage: VIMVIEW [[drive:][path]filename.vim] [ResX] [ResY]');
 Writeln('Hint: use arrow keys to scroll screen and "Esc" to exit');
 Name:=ParamStr(1);
 XRes:=StrToInt(ParamStr(2));
 YRes:=StrToInt(ParamStr(3));
 if Name[Length(Name)-3]='.' then begin
  Main:=Copy(Name,1,Length(Name)-4);
  Ext:=Copy(Name,Length(Name)-3,4);
 end else begin
  Main:=Name;
  Ext:='.vim'
 end;
 GetBuffer(P,768);
 Np:=SizeOfFile(Main+'.pal');
 if Np>768 then Np:=0;
 pl:=ReadFromFile(Main+'.pal',P,0,Np);
 Np:=trunc(Np/3);
 N:=SizeOfFile(Main+Ext);
 if N=0 then begin
  Writeln('Can`t read ',Main+Ext,'!');
  exit;
 end;
 GetBuffer(P1,N);
 if P1=nil then begin
  Writeln('Out of memory!');
  exit;
 end;
 ReadFromFile(Main+Ext,P1,0,n);
 if not GetVIMWH(dx,dy,p1) then begin
  Writeln(Main+Ext,' is a not VIM file!');
  exit;
 end;
 grMode:=(xGetByte(P1,3) shr 5)+grSVGA256;
 if grMode>grSVGA256 then inc(grMode);
 if (XRes=0) or (YRes=0) then begin
  XRes:=640;
  YRes:=480;
 end;
 if (XRes=320) and (YRes=200) and (grMode=grSVGA256) then
  SetMCGAMode else begin
  if not InitVBE then begin
   Writeln('VESA VBE 1.2 required. VESA VBE 2.0/3.0 recomended.');
  end;
  if not SetSVGAMode(XRes,YRes,grMode) then begin
   Writeln('Can`t initialize required video mode!');
   exit;
  end;
 end;
 X:=0; Y:=0;
 if x>360 then Step:=4 else Step:=2;
 if dy<mgYRes then y:=y+trunc((mgYRes-dy)/2);
 if dx<mgXRes then x:=x+trunc((mgXRes-dx)/2);
 if Pl=false then SetVGAPalette(p,0,np);
 FlushKeys:=true;
 MultiKeysInit;
 Show:=true;
 repeat
  if Show then begin
   if (not Pl) and (PalFlag) then PutVIM(X,Y,P1,false);
   if (Pl) and (not PalFlag) then begin
    SetVGAPalette(P,0,Np);
    PutVIM(X,Y,P1,false); PalFlag:=true;
   end;
   if (not Pl) and (not PalFlag) then begin
    PutVIM(X,Y,P1,true); PalFlag:=true;
   end;
   Show:=false;
  end;
  if (TestKey($50)) and (y+dy-step-1>mgYRes) then begin dec(y,step); Show:=true; end;
  if (TestKey($48)) and (y+step<0) then begin inc(y,step); Show:=true; end;
  if (TestKey($50)) and (y+dy-1>mgYRes) then begin dec(y,1); Show:=true; end;
  if (TestKey($48)) and (y<0) then begin inc(y,1); Show:=true; end;
  if (TestKey($4d)) and (x+dx-step-1>mgXRes) then begin dec(x,step); Show:=true; end;
  if (TestKey($4b)) and (x+step<0) then begin inc(x,step); Show:=true; end;
  if (TestKey($4d)) and (x+dx-1>mgXRes) then begin dec(x,1); Show:=true; end;
  if (TestKey($4b)) and (x<0) then begin inc(x,1); Show:=true; end;
 until TestKey(1);
 MultiKeysDone;
 FreeBuffer(p1,n);
 FreeBuffer(p,768);
 SetTextMode;
 Writeln;
 Writeln('File ',name,' is a VGA image: ',Dx,'x',Dy,', ',(grMode-grSVGA16)*8,' bps');
 Writeln;
end.
