program clock; (* Original code from SWAG.
  Converted to VRg SuperVGA lib demo by Asp //VR group, 1998 *)


{$S-,Q-,R-,V-,B-,X+,G+,N+}
uses crt,dos,SVGA;

const
  cijfers :array[0..9,0..6,1..2] of byte =
     (((128,60),(140,11),(134,60),(146,60),(152,60),(158,60),(164,60)),  {0}
      ((128,11),(140,11),(134,11),(146,11),(152,11),(158,60),(164,60)),  {1}
      ((128,60),(140,60),(134,60),(146,11),(152,60),(158,60),(164,11)),  {2}
      ((128,60),(140,60),(134,60),(146,11),(152,11),(158,60),(164,60)),  {3}
      ((128,11),(140,60),(134,11),(146,60),(152,11),(158,60),(164,60)),  {4}
      ((128,60),(140,60),(134,60),(146,60),(152,11),(158,11),(164,60)),  {5}
      ((128,60),(140,60),(134,60),(146,60),(152,60),(158,11),(164,60)),  {6}
      ((128,60),(140,11),(134,11),(146,11),(152,11),(158,60),(164,60)),  {7}
      ((128,60),(140,60),(134,60),(146,60),(152,60),(158,60),(164,60)),  {8}
      ((128,60),(140,60),(134,60),(146,60),(152,11),(158,60),(164,60))); {9}


var
  p,pp,q,i          :integer;
  ch                :char;
  dis               :array[1..6] of string[1];
  d                 :array[1..6] of byte;
  cx,cy             :integer;
  start             :boolean;

procedure run_klok;{********************************************************}

var h,m,sec,hund :word;
  st :string[10];

function leading(w :word) :string;

begin
  str(w:0,st);
  if length(st) =1 then st :='0' +st;
  leading :=st;
end;

begin
  gettime(h,m,sec,hund);

  dis[1] :=copy(leading(h),1,1);val(dis[1],d[1],q);
  dis[2] :=copy(leading(h),2,1);val(dis[2],d[2],q);
  dis[3] :=copy(leading(m),1,1);val(dis[3],d[3],q);
  dis[4] :=copy(leading(m),2,1);val(dis[4],d[4],q);
  dis[5] :=copy(leading(sec),1,1);val(dis[5],d[5],q);
  dis[6] :=copy(leading(sec),2,1);val(dis[6],d[6],q);

  { SET CLOCK ON TIME }
  if start =false then for p :=0 to 6 do begin
    _SetColor(cijfers[d[1],p,1],cijfers[d[1],p,2],0,0);
    _SetColor(cijfers[d[2],p,1]+1,cijfers[d[2],p,2],0,0);
    _SetColor(cijfers[d[3],p,1]+2,cijfers[d[3],p,2],0,0);
    _SetColor(cijfers[d[4],p,1]+3,cijfers[d[4],p,2],0,0);
    _SetColor(cijfers[d[5],p,1]+4,cijfers[d[5],p,2],0,0);
    _SetColor(cijfers[d[6],p,1]+5,cijfers[d[6],p,2],0,0);
    start :=true;
  end;

  if (d[3]=0) and (d[4]=0) and (d[5]=0) and (d[6]=0) then
    for p :=0 to 6 do begin
    _SetColor(cijfers[d[1],p,1],cijfers[d[1],p,2],0,0);
    _SetColor(cijfers[d[2],p,1]+1,cijfers[d[2],p,2],0,0);
  end;

  if (d[4]=0) and (d[5]=0) and (d[6]=0) then for p :=0 to 6 do
      _SetColor(cijfers[d[3],p,1]+2,cijfers[d[3],p,2],0,0);

  if (d[5] =0) and (d[6]=0) then for p :=0 to 6 do
      _SetColor(cijfers[d[4],p,1]+3,cijfers[d[4],p,2],0,0);
  if d[6] =0 then for p :=0 to 6 do
      _SetColor(cijfers[d[5],p,1]+4,cijfers[d[5],p,2],0,0);

  for p :=0 to 6 do
      _SetColor(cijfers[d[6],p,1]+5,cijfers[d[6],p,2],0,0);
end;

procedure draw_display;{****************************************************}

begin
  cx :=100;cy :=100;
  _Box(cx-10,cy-8,cx+410,cy+109,0,0);
  for pp :=0 to 5 do begin
    if pp in[2,4] then inc(cx,20);

    _Box(cx-7+(pp*70),cy-5,cx+57+(pp*70),cy+106,19,0);
    for i:=cy-4 to cy+105 do    (* Emulate fill pattern *)
     _MaskedLine(cx-6+(pp*70),i,cx+56+(pp*70),i,19,$5555 shl (i mod 2));

    { BOVENSTE SEGMENT }
    _Line(cx+(pp*70),cy,cx+50+(pp*70),cy,128+pp);
    _Line(cx+1+(pp*70),cy-1,cx+49+(pp*70),cy-1,128+pp);
    _Line(cx+2+(pp*70),cy-2,cx+48+(pp*70),cy-2,128+pp);
    for p :=1 to 4 do _Line(cx+p+(pp*70),cy+p,cx+50-p+(pp*70),cy+p,128+pp);

    { MIDDELSTE SEGMENT }
    for p :=2 to 5 do _Line(cx+p+(pp*70),cy+52-p,cx+50-p+(pp*70),cy+52-p,140+pp);
    for p :=2 to 5 do _Line(cx+p+(pp*70),cy+49+p,cx+50-p+(pp*70),cy+49+p,140+pp);

    { ONDERSTE SEGMENT }
    _Line(cx+(pp*70),cy+100,cx+50+(pp*70),cy+100,134+pp);
    _Line(cx+1+(pp*70),cy+101,cx+49+(pp*70),cy+101,134+pp);
    _Line(cx+2+(pp*70),cy+102,cx+48+(pp*70),cy+102,134+pp);
    for p :=1 to 4 do _Line(cx+p+(pp*70),cy+100-p,cx+50-p+(pp*70),cy+100-p,134+pp);

    { SEGMENT LINKSBOVEN }
    _Line(cx+(pp*70),cy+5,cx+(pp*70),cy+47,146+pp);
    for p :=1 to 2 do _Line(cx+p+(pp*70),cy+5+p,cx+p+(pp*70),cy+47-p,146+pp);
    _Line(cx-1+(pp*70),cy+4,cx-1+(pp*70),cy+46,146+pp);
    _Line(cx-2+(pp*70),cy+3,cx-2+(pp*70),cy+45,146+pp);
    _Line(cx-3+(pp*70),cy+4,cx-3+(pp*70),cy+44,146+pp);

    { SEGMENT LINKSONDER }
    _Line(cx+(pp*70),cy+54,cx+(pp*70),cy+96,152+pp);
    for p :=1 to 2 do _Line(cx+p+(pp*70),cy+54+p,cx+p+(pp*70),cy+96-p,152+pp);
    _Line(cx-1+(pp*70),cy+55,cx-1+(pp*70),cy+97,152+pp);
    _Line(cx-2+(pp*70),cy+56,cx-2+(pp*70),cy+98,152+pp);
    _Line(cx-3+(pp*70),cy+57,cx-3+(pp*70),cy+97,152+pp);

    { SEGMENT RECHTSBOVEN }
    _Line(cx+50+(pp*70),cy+5,cx+50+(pp*70),cy+47,158+pp);
    for p :=1 to 2 do _Line(cx+50-p+(pp*70),cy+5+p,cx+50-p+(pp*70),cy+47-p,158+pp);
    _Line(cx+50+1+(pp*70),cy+4,cx+50+1+(pp*70),cy+46,158+pp);
    _Line(cx+50+2+(pp*70),cy+3,cx+50+2+(pp*70),cy+45,158+pp);
    _Line(cx+50+3+(pp*70),cy+4,cx+50+3+(pp*70),cy+44,158+pp);

    { SEGMENT RECHTSONDER }
    _Line(cx+50+(pp*70),cy+54,cx+50+(pp*70),cy+96,164+pp);
    for p :=1 to 2 do _Line(cx+50-p+(pp*70),cy+54+p,cx+50-p+(pp*70),cy+96-p,164+pp);
    _Line(cx+50+1+(pp*70),cy+55,cx+50+1+(pp*70),cy+97,164+pp);
    _Line(cx+50+2+(pp*70),cy+56,cx+50+2+(pp*70),cy+98,164+pp);
    _Line(cx+50+3+(pp*70),cy+57,cx+50+3+(pp*70),cy+97,164+pp);
  end;

  { DUBBELE PUNTEN }
  _WriteStr(237,120,chr(219),7);
  _WriteStr(237,173,chr(219),7);
  _WriteStr(397,120,chr(219),7);
  _WriteStr(397,173,chr(219),7);
end;

procedure FONT;external;
{$L FONT.OBJ}

begin
  _SetFont(@FONT);
  _SetMode(_640x480);
  _TransparentColor:=255;
  start :=false;
  for p :=128 to 169 do _SetColor(p,15,0,0);    { set colors 128 to 169 }
                                                   { in darkred }

  for p :=1 to 1000 do _PutPixel(random(638),random(479),random(12)+20);

  _WriteStr(240,260,'ESCAPE IS STOP CLOCK',9);
  _WriteStr(241,261,'ESCAPE IS STOP CLOCK',1);

  draw_display;
  repeat
    repeat
      _WaitVSync;
      run_klok;
    until keypressed;
    ch :=readkey;
  until ch in[#27];
 _SetTextMode;
end.
