(*******************************************)
(* VRg SuperVGA library font viewer        *)
(*******************************************)
(* Example program for VRg SuperVGA libray *)
(* Copyleft (C) 1998-1999 Virtual research *)
(*******************************************)

program txfview;
{$S-,D-,Y-,L-,Q-,R-,V-,G+,E+,N+}
uses CRT,SVGA;
var i,j:byte;
    fontbuffer:array[1..4096] of byte;
    dummy:integer;
    f:file;

const HexDigits:array[0..15] of char='0123456789ABCDEF';

procedure FONT;external;
{$L FONT.OBJ}

begin
 if not _VESAPresent then begin
  WriteLn(#13+#10+'I need VESA!');
  Halt;
 end;
 if (ParamCount<>1) or (Pos('?',ParamStr(1))<>0) then begin
  WriteLn(#13+#10+'Gimme a TXF file name :)');
  Halt;
 end;
 Assign(f,ParamStr(1));
 {$I-}
 Reset(f,1);
 if IOResult<>0 then begin
  WriteLn(#13+#10+'Could not open font file!');
  Halt;
 end;
 BlockRead(f,fontbuffer,4096,dummy);
 if IOResult<>0 then begin
  WriteLn(#13+#10+'Could not read from font file!');
  Close(f);
  Halt;
 end;
 Close(f);
 if not _SetMode(_640x480) then begin
  _SetTextMode;
  WriteLn(#13+#10+'Ooops... Could not set 640x480x256...');
  Halt;
 end;
 _SetFont(@FONT);
 for i:=0 to 15 do _WriteStr((i+12)*16,5*16,HexDigits[i],9);
 for i:=0 to 15 do _WriteStr(10*16,(i+7)*16,HexDigits[i],9);
 _SetFont(@fontbuffer);
 for i:=0 to 15 do
  for j:=0 to 15 do
   _WriteStr((j+12)*16,(i+7)*16,Chr(i*16+j),15);
 ReadKey;
 _SetTextMode;
end.
