(********************************************)
(* Waving pattern with smoothing            *)
(********************************************)
(* Example program for VRg SuperVGA library *)
(* Copyleft (C) 1999 Virtual Research       *)
(********************************************)

{.$D+,L+,Y+}
{$S-,R-,Q-,V-,B-,X+}
uses LFB256,BMFX,CRT,SinTable;

var Bm1,Bm2:TBitmap;
    Palette:TPalette;

{$i vrlogo.inc}

procedure DistortPattern;
var i,Arg,ShiftValue:word;
const Phase:word=0;
begin
 Move(Bm1.Body^,Bm2.Body^,64000);
 if Phase=360 then Phase:=0;
 for i:=0 to 199 do begin
  Arg:=i*11+Phase;
  if Arg>=360 then Arg:=Arg mod 360;
  ShiftValue:=word(Sine[Arg]+16384) div 4000+1;
  bmShiftLine(Bm2,i,ShiftValue);
 end;
 for i:=0 to 199 do begin
  Arg:=i*11+Phase;
  if Arg>=360 then Arg:=Arg mod 360;
  ShiftValue:=word(Sine[Arg]+16384) div 4000+1;
  bmShiftColumn(Bm2,i,ShiftValue);
 end;
 Inc(Phase,1);
 bmSmooth(Bm2,@VRLogo);
 _PutImage(60,0,200,200,Bm2.Body);
end;

begin
 _Get_PCX_Palette('vrlogo.pcx',Palette);
 _VGA13_Init;
 _SetMode(_320x200);
 _SetPalette(Palette);
 GetMem(Bm1.Body,40000);
 GetMem(Bm2.Body,40000);
 with Bm1,Bm2 do begin
  Width:=200;
  Height:=200;
 end;
 _PCX_Buffer('vrlogo.pcx',0,Bm1.Body);
 repeat
  DistortPattern;
 until KeyPressed;
 ReadKey;
 _SetTextMode;
end.
