(********************************************)
(* Simple rotazoomer                        *)
(********************************************)
(* Example program for VRg SuperVGA library *)
(* Copyleft (C) 1998-1999 Virtual Research  *)
(********************************************)

{$R-,Q-,S-,V-,B-,X+}
uses lfb256,bmfx,CRT,BIOSTime;

var Bm1,Bm2:TBitmap;
    Pal:TPalette;
    i,s:word;
    sinc:shortint;
    FrameCount:dword;
    FPS:string;

{$I FONT.INC}

begin
 _VGA13_Init;
 _SetMode(_320x200);
 GetMem(Bm1.Body,200*200);
 GetMem(Bm2.Body,200*200);
 _Get_PCX_Palette('vrlogo.pcx',Pal);
 _SetPalette(Pal);
 _PCX_Buffer('vrlogo.pcx',0,Bm1.Body);
 _SetFont(@FONT);
 Bm1.Width:=200; Bm1.Height:=200;
 Bm2.Width:=200; Bm2.Height:=200;
 s:=1; sinc:=1;
 _WriteOverlappedText(0,0,'FPS:',42,0);
 _WriteOverlappedText(0,17,'wait...',42,0);
 repeat
  FrameCount:=0; TimerReset;
  for i:=0 to 359 shr 1 do begin 
   if KeyPressed then Break;
   bmRotScale(Bm1,Bm2,80,110,i shl 1,s);
   Inc(s,sinc); if (s>600) or (s<2) then sinc:=-sinc; 
   _PutImage(60,0,200,200,Bm2.Body);
   Inc(FrameCount);
  end; 
  Str(FrameCount/TimerRead:6:2,FPS);
  _WriteOverlappedText(0,17,FPS+' ',42,0);
 until KeyPressed;
 FreeMem(Bm1.Body,200*200);
 FreeMem(Bm2.Body,200*200);
 ReadKey;
 _SetTextMode;
end.




