(********************************************)
(* Translucency demonstration               *)
(********************************************)
(* Example Program for VRg SuperVGA library *)
(* Copyleft (C) 1998-1999 Virtual Research  *)
(********************************************)

program TrnsDemo;
uses lfb256,trans256,crt;

{$I SPLASH.INC}  

var VirtualScreen,Background,Foreground:pointer;
    Palette:TPalette;
    x,y:word;
    yInc,xInc:integer;

begin
 transSetTable(@SPLASH);
 _VBE2_Init;                            (* Initialize graphics *)
 _SetMode(_640x480);                    (* Set videomode *)
 GetMem(VirtualScreen,640*480);         (* Allocate buffers *)
 GetMem(Background,640*480);
 GetMem(Foreground,320*200);
 _Get_PCX_Palette('splash.pcx',Palette);     (* Load palette *)
 _SetPalette(Palette);
 _PCX_Buffer('splash.pcx',0,Background);     (* Load background *)
 _PCX_Buffer('splashlr.pcx',0,Foreground);     (* and foreground images *)
 _SetVirtualOutput(VirtualScreen);    (* Redirect output to virtual buffer *)
 x:=320; y:=240;
 Randomize;
 yInc:=Random(3)+1; xInc:=Random(3)+1;   (* Start values for coordinates *)
 while not KeyPressed do begin           (* increment *)
  _PutImage(0,0,640,480,BackGround);     (* Redraw background *)
  transPutImage(x-160,y-100,320,200,Foreground);  (* Put translucent image *)
  _Rectangle(x-160,y-100,x+160,y+100,121);
  Inc(x,xinc);                         (* Alter coordinates increment *)
  Inc(y,yinc);
  if x>476 then xinc:=-Random(3)-1;   (* "Bounce" effect *)
  if x<164 then xinc:=Random(3)+1;
  if y>376 then yinc:=-Random(3)-1;
  if y<104 then yinc:=Random(3)+1;
                                      (* Uncomment next line for smoother
                                         animation *)
{ _WaitForVSyncStart; }
  _FlushVirtualScreen(VirtualScreen);   (* Flush virtual buffer *)
 end;
 ReadKey;                                       (* Clear keyboard buffer *)
 _InitStepFade(Palette,_BlankPalette,70);   (* Start palette fading *)
 while _StepFade do begin         (* Do animation while palette is fading *)
  _PutImage(0,0,640,480,BackGround);
  transPutImage(x-160,y-100,320,200,Foreground);
  _Rectangle(x-160,y-100,x+160,y+100,121);
  Inc(x,xinc);
  Inc(y,yinc);
  if x>476 then xinc:=-Random(3)-1;
  if x<164 then xinc:=Random(3)+1;
  if y>376 then yinc:=-Random(3)-1;
  if y<104 then yinc:=Random(3)+1;
{ _WaitForVSyncStart; }
  _FlushVirtualScreen(VirtualScreen);
 end;

 FreeMem(VirtualScreen,640*480);        (* Deallocate buffers *)
 FreeMem(Background,640*480);
 FreeMem(Foreground,320*200);
 _SetTextMode;                (* Set 80x25x16 text mode (this line is not
                                 necessary, you have to put it here just in
                                 case if you want to write some messages at
                                 the console before program ends) *)
end.


