{$g+,n-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,x+,i-}

uses MegaGraf,Keyboard,GfxFont,MemPlus,Fonts,DosUtil;

(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 var Pal1,Ted1,Pal2,Ted2,Pal3,Ted3,Pal4,Ted4: Pointer;
     Mode:       String;
     CC,CI,CL,I: LongInt;

 function LoadData(Name: String): Pointer;
 var Tmp: Pointer;
 begin
  Tmp:=LoadFile(Name);
  if Tmp=nil then begin
   Writeln(' Can`t load ',Name);
   Halt(0);
  end;
  LoadData:=Tmp;
 end;

 procedure FillPattern;
 var value,i: LongInt;
     MX,MY:   Word;
 begin
  MX:=mgXRes-1;
  MY:=mgYRes-1;
  ClearVideoMem;
  for i:=0 to MX do begin
   DrawLine(MX shr 1,MY shr 1,i,0,RGBColor((i*mgRedMask) div MX,0,0));
   DrawLine(MX shr 1,MY shr 1,i,MY,RGBColor(0,(i*mgGreenMask) div MX,0));
  end;
  for i:=0 to MY do begin
   value:=Word((i*mgBlueMask) div MY);
   DrawLine(MX shr 1,MY shr 1,0,i,RGBColor(value,0,mgBlueMask-value));
   DrawLine(MX shr 1,MY shr 1,MX,i,RGBColor(0,mgGreenMask-value,value));
  end;
 end;

 begin
  Ted1:=LoadData('font018.ted');
  Pal1:=LoadData('font018.pal');
  Ted2:=LoadData('font007.ted');
  Pal2:=LoadData('font007.pal');
  Ted3:=LoadData('font016.ted');
  Pal3:=LoadData('font016.pal');
  Ted4:=LoadData('font010.ted');
  Pal4:=LoadData('font010.pal');
  if not InitVBE then begin Writeln(' VESA 1.2/2.0 needed!'); exit; end;
  if not SetSVGAMode(640,480,grSVGA4G) then
   if not SetSVGAMode(640,480,grSVGA16M) then
    if not SetSVGAMode(640,480,grSVGA64K) then
     if not SetSVGAMode(640,480,grSVGA32K) then begin
      SetTextMode;
      Writeln(' True/Hi Color SVGA modes not supported!');
      exit;
  end;
  SetTEDFont(Ted1,Pal1);
  SetTransp(true);
  FillPattern;
  WriteXY(18,40,'TED 256 COLORED FONTS IN SVGA TRUE COLOR');
  WriteXY(18,60,'TED 256 COLORED FONTS IN SVGA TRUE COLOR');
  WriteXY(18,80,'TED 256 COLORED FONTS IN SVGA TRUE COLOR');
  SetTEDFont(Ted3,Pal3);
  WriteXY(240,0,'COOL DEMO');
  SetTEDFont(Ted2,Pal2);
  FontSpacing:=-1;
  WriteXY(5,150,'THIS TEST SHOW YOU HOW TO USE 256 COLORED');
  WriteXY(5,180,'FONTS IN ANY GRAPHIC MODE WHICH SUPPORTED');
  WriteXY(170,210,'BY PLUS SYSTEM PRO 2');
  SetTEDFont(Ted4,Pal4);
  FontSpacing:=0;
  WriteXY(10,280,'THIS PROGRAM WILL WORK');
  WriteXY(30,330,'IN SVGA HI COLOR AND');
  WriteXY(90,380,'TRUE COLOR MODES');
  SetChars(@Rus8x16d,1,16,0,1);
  case mgBitsPerPixel of
   15: Mode:='32K (Hi Color)';
   16: Mode:='64K (Hi Color)';
   24: Mode:='16M (True Color)';
   32: Mode:='16M+A (True Color)';
  end;
  CC:=0; CI:=1;
  if mgColorMode>grSVGA64k then CL:=255 else CL:=31;
  repeat
   PutStringXY(50,440,' Current video mode is SVGA '+IntToStr(mgXRes)+' x '+
   IntToStr(mgYRes)+' x '+Mode,RGBColor(CC,CC,CC));
   CC:=CC+CI;
   if (CC=0) or (CC=CL) then CI:=-CI;
   for i:=0 to 70 do HRetrace;
  until xKeyPressed;
  FlushKeyboard;
  SetTextMode;
 end.