{$g+,n+,d-,l-,b-,r-,o-,f-,s-,a+,e+,p-,q-,t+,v-,x+,i-}

(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 Copyright (c) 1996-98 by Vadim Bodrov  |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

 uses FixedLib,ZenTimer,i80386;

 var sfl,sfx,i:  LongInt;
     a1,b1,c1,d1,t1: Real;
     a2,b2,c2,d2,t2,c,s: FixedPoint;

 begin
   a1:=0.123;
   b1:=876.21;
   t1:=10.1;
   d1:=30*pi/180;
   Write('Floating-point instructions test, please wait... ');
   LZTimerOn;
   for i:=0 to 300000 do c1:=b1/a1+t1;
   for i:=0 to 300000 do c1:=a1*b1/a1+sin(d1);
   LZTimerOff;
   sfl:=LZTimerCount div 100000;
   Writeln(sfl,' 10*s');

   a2:=RealToFixed(0.123);
   b2:=RealToFixed(876.21);
   t2:=RealToFixed(10.1);
   d2:=30;
   Write('Fixed-point instructions test, please wait...    ');
   LZTimerOn;
   for i:=0 to 300000 do c2:=FixedAdd(FixedDiv(b2,a2),t2);
   for i:=0 to 300000 do begin
    cossin(d2,c,s);
    c2:=FixedAdd(FixedDiv(FixedMul(a2,b2),a2),s);
   end;
   LZTimerOff;
   sfx:=LZTimerCount div 100000;
   Writeln(sfx,' 10*s');

   if sfl>sfx then
    Writeln('Fixed-point operations is about ',Round(sfl/sfx),' times faster!');

 end.
