{$g+,n-,d-,l-,b-,r-,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*       FONTS LIBRARY /I80386 AND HIGHER, REAL MODE, PROTECTED MODE       *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996,97   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit Fonts;

 interface

 procedure Lat8x8;
 procedure Lat8x14;
 procedure Lat8x16;
 procedure Rus8x8;
 procedure Rus8x14;
 procedure Rus8x16;

 procedure Rus8x14a;
 procedure Rus8x14b;
 procedure Rus8x14c;
 procedure Rus8x14d;
 procedure Rus8x16a;
 procedure Rus8x16b;
 procedure Rus8x16c;
 procedure Rus8x16d;

 procedure SetSystemFont;
 procedure SetFont (FontAddr: Pointer; CharHigh: Byte);

 implementation

{$IFDEF MSDOS}
 uses Version;
{$ELSE}
 uses DOSUtil,MemPlus;
{$ENDIF}

 {$L Lat8x8.obj}
 procedure Lat8x8; external;
 {$L Lat8x14.obj}
 procedure Lat8x14; external;
 {$L Lat8x16.obj}
 procedure Lat8x16; external;
 {$L Rus8x8.obj}
 procedure Rus8x8; external;
 {$L Rus8x14.obj}
 procedure Rus8x14; external;
 {$L Rus8x16.obj}
 procedure Rus8x16; external;

 {$L Rus8x14a.obj}
 procedure Rus8x14a; external;
 {$L Rus8x14b.obj}
 procedure Rus8x14b; external;
 {$L Rus8x14c.obj}
 procedure Rus8x14c; external;
 {$L Rus8x14d.obj}
 procedure Rus8x14d; external;
 {$L Rus8x16a.obj}
 procedure Rus8x16a; external;
 {$L Rus8x16b.obj}
 procedure Rus8x16b; external;
 {$L Rus8x16c.obj}
 procedure Rus8x16c; external;
 {$L Rus8x16d.obj}
 procedure Rus8x16d; external;

 procedure SetSystemFont; assembler;
      asm
        mov     ax,$1104
        xor     bx,bx
        int     $10
  end;

 procedure SetFont (FontAddr: Pointer; CharHigh: Byte);
{$IFDEF MSDOS}
 assembler;
      asm
        push    bp
        mov     ax,$1110
        xor     bx,bx
        mov     bh,[CharHigh]
        mov     cx,$FF
        xor     dx,dx
        les     bp,[FontAddr]
        int     $10
        pop     bp
 end;
{$ELSE}
 var FontPtr: Pointer;
     Regs : TRealRegs;
  begin
   ClearRegs(Regs);
   Regs.ES:=xGlobalDosAlloc(FontPtr,Word(CharHigh)*256);
   xMove(FontAddr,FontPtr,Word(CharHigh)*256);
   Regs.BP:=$0000;
   Regs.AX:=$1110;
   Regs.BH:=CharHigh;
   Regs.BL:=$00;
   Regs.CX:=$00FF;
   Regs.DX:=$0000;
   RealModeInt($10,Regs);
   xGlobalDosFree(FontPtr);
  end;
{$ENDIF}

 end.
