{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*                        TARGA TO VIM CONVERTOR                           *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

uses DosUtil,MemPlus,i80386;
var
  id:                 String;
  Name:               String;
  Offset:             LongInt;
  mgBufferPtr,P:      Pointer;
  Dx,Dy:              Word;
  Sp:                 Byte;
  S,E,i,j:            Word;
  TGAPalB:            Byte;
  BPP:                Byte;
  Dsc:                Byte;
  lp,pp:              Boolean;
  VIMfile:            File;
  Convert:            Boolean;

 procedure TGAPalConv(BPP: Byte; StartC,EndC: Word; Addr: Pointer); near;
 var C: Word;
 begin
  case BPP of
   16: repeat
        C:=GetWord(Addr);
        asm
        les     di,[mgBufferPtr]
        mov     ax,[StartC]
        shl     ax,1
        add     di,ax
        mov     ax,[C]
        xchg    al,ah
        mov     cl,5
        and     al,00011111b
        stosb
        shr     ax,cl
        and     al,00011111b
        stosb
        shr     ax,cl
        and     al,00011111b
        stosb
        end;
        IncPointer(Addr,2);
        inc(StartC);
       until StartC=EndC;
    24:repeat
        xPutByte(mgBufferPtr,StartC*3,xGetByte(Addr,2) shr 2);
        xPutByte(mgBufferPtr,StartC*3+1,xGetByte(Addr,1) shr 2);
        xPutByte(mgBufferPtr,StartC*3+2,Byte(Addr^) shr 2);
        IncPointer(Addr,3);
        inc(StartC);
       until StartC=EndC;
    32:repeat
        xPutByte(mgBufferPtr,StartC*3,xGetByte(Addr,2) shr 2);
        xPutByte(mgBufferPtr,StartC*3+1,xGetByte(Addr,1) shr 2);
        xPutByte(mgBufferPtr,StartC*3+2,Byte(Addr^) shr 2);
        IncPointer(Addr,4);
        inc(StartC);
       until StartC=EndC;
   end;
 end;

 procedure Conv64K(DX: Word; P: Pointer);
 var k:  Word;
     cv: Word;
 begin
  { 32K to 64K }
  if Convert then begin
   for k:=0 to Dx-1 do begin
    cv:=xGetWord(P,k*2);
    cv:=((cv and $FFE0) shl 1) or (cv and $1F);
    xPutWord(P,k*2,cv);
   end;
  end;
 end;

begin
  id:='VIM'+chr(0)+chr(0);
  Write('Uncompressed TARGA (pallette and RGB colored) to VIM Convertor');
{$IFDEF DPMI}
  Writeln(' // Protected Mode');
{$ELSE}
  Writeln(' // Real Mode');
{$ENDIF}
  Writeln('Copyright (c) 1996-98 by Vadim Bodrov (falkoris@hotmail.com)');
  Writeln('This program is a part of PLUS SYSTEM Pro 2.0 GDK FOR BORLAND PASCAL');
  Writeln('Usage: TGA2VIM [/p] [/n] [/c] [[drive:][path]filename.tga');
  Writeln('               [/p]  - store palette in a .PAL file (Palette only)');
  Writeln('               [/n]  - do not link palette with VIM (Palette only)');
  Writeln('               [/c]  - convert TARGA 32K to VIM 64K (HiColor only)');
  if ((paramcount>3) or (paramcount=0)) or
     ((paramcount=1) and (paramstr(1)='/?')) then exit;
  for i:=1 to ParamCount do begin
   if (ParamStr(i)='/p') or (ParamStr(i)='/P') then pp:=true;
   if (ParamStr(i)='/n') or (ParamStr(i)='/N') then lp:=true;
   if (ParamStr(i)='/c') or (ParamStr(i)='/C') then Convert:=true;
   if Copy(ParamStr(i),1,1)<>'/' then Name:=ParamStr(i);
  end;
  if copy(Name,length(name)-3,1)<>'.' then Name:=Name+'.tga';
  if not TestFile(Name) then begin
   Writeln('File ',Name+' not found...'); Halt(0);
  end;
  GetBuffer(P,18);
  ReadFromFile(Name,P,0,18);
  BPP:=xGetByte(P,16);
  if (xGetByte(P,1)>1) or (xGetByte(P,2)>2) or (not BPP in [8,16,24,32]) then begin
    Writeln('Can`t proceed this file...');
    Halt(0);
  end;
  Dx:=xGetWord(P,12);
  Dy:=xGetWord(P,14);
  Sp:=GetByte(P);
  S:=xGetWord(P,3);
  E:=S+xGetWord(P,5);
  TGAPalB:=xGetByte(P,7);
  Dsc:=xGetByte(P,17);
  FreeBuffer(P,18);
  GetBuffer(mgBufferPtr,768);
  Offset:=18+Sp;
  if BPP=8 then begin
   GetBuffer(P,4*256);
   ReadFromFile(Name,P,Offset,(TGAPalB shr 3)*(E-S));
   TGAPalConv(TGAPalB,S,E,P);
   if pp then begin
    Assign(VIMfile,Copy(Name,1,Length(Name)-4)+'.pal');
{$i-}
    ReWrite(VIMfile,1);
    BlockWrite(VIMfile,mgBufferPtr^,E*3);
    Close(VIMfile);
{$i+}
   end;
   FreeBuffer(P,4*256);
   Offset:=Offset+(TGAPalB shr 3)*(E-S);
  end;
  GetBuffer(P,LongMul(Dx,(BPP+1) div 8));
  case BPP of
   8:     id[4]:=chr(0);
   15,16: id[4]:=chr(1 shl 5);
   24:    id[4]:=chr(2 shl 5);
   32:    id[4]:=chr(3 shl 5);
  end;
  id[5]:=chr(S);
  Assign(VIMfile,Copy(Name,1,Length(Name)-4)+'.vim');
{$i-}
  ReWrite(VIMfile,1);
  BlockWrite(VIMfile,id[1],5);
  if (BPP=8) and (not lp) then E:=E-S else begin E:=0; S:=0; end;
  BlockWrite(VIMfile,E,2);
  if E>0 then BlockWrite(VIMfile,mgBufferPtr^,E*3);
  BlockWrite(VIMfile,Dx,2);
  BlockWrite(VIMfile,Dy,2);
  if (Dsc and $20)=0 then begin
   Offset:=Offset+LongMul(Dy-1,LongMul(Dx,(BPP+1) div 8));
   for i:=1 to Dy do begin
    ReadFromFile(Name,P,Offset,LongMul(Dx,(BPP+1) div 8));
    if BPP in [15,16] then Conv64K(DX,P);
    BlockWrite(VIMfile,P^,LongMul(Dx,(BPP+1) div 8));
    Dec(Offset,LongMul(Dx,(BPP+1) div 8));
   end;
  end else begin
   for i:=1 to Dy do begin
    ReadFromFile(Name,P,Offset,LongMul(Dx,(BPP+1) div 8));
    if BPP in [15,16] then Conv64K(DX,P);
    BlockWrite(VIMfile,P^,LongMul(Dx,(BPP+1) div 8));
    Inc(Offset,LongMul(Dx,(BPP+1) div 8));
   end;
  end;
  Close(VIMFile);
  GetBuffer(P,LongMul(Dx,(BPP+1) div 8));
{$i+}
  if IOResult=0 then begin
   Writeln('Output VIM file info:');
   Writeln('File Name    - ',Copy(Name,1,Length(Name)-4)+'.vim');
   Writeln('File Size    - ',SizeOfFile(Copy(Name,1,Length(Name)-4)+'.VIM'));
   Writeln('Color Depth  - ',BPP,' bpp');
   Writeln('Image Lenght - ',Dx);
   Writeln('Image Width  - ',Dy);
  end else Writeln('Can`t create file...');
end.
