(********************************************)
(* Figures                                  *)
(********************************************)
(* Example program for VRg SuperVGA library *)
(* Copyleft (C) 1996-1998 Virtual Research  *)
(********************************************)

program figures;
{$R-,Q-,S-,V-,B-,X+,G+,N+}
uses svga,crt;

var a4,a3,b4,b3,c1,d,t:real;
    x,y,x2,y2:word;
    c:byte;

procedure FadeInColor;
var i:byte;
begin
 for i:=0 to 63 do begin
  _WaitVSync;
  _SetColor(15,i,i,i);
  delay(20);
 end;
end;

procedure FadeOutColor;
var i:byte;
begin
 for i:=63 downto 0 do begin
  _WaitVSync;
  _SetColor(15,i,i,i);
  delay(20);
 end;
end;


begin
 Randomize;
 _SetMode(_1024x768);
 repeat
  FadeOutColor;
  _Fill(0);
  a4:=5*(Random(10000)/10000);
  a3:=5*(Random(10000)/10000);
  b4:=5*(Random(10000)/10000);
  b3:=5*(Random(10000)/10000);
  c1:=10*(Random(10000)/10000);
  t:=0;
  while t<12.6 do begin
   d:=t+c1;
   x:=Round((2*cos(a4*t)-cos(a3*2*t)+3)*(1024 div 6));
   x2:=Round((2*cos(a4*d)-cos(a3*2*d)+3)*(1024 div 6));
   y:=Round((2*sin(b4*t)-sin(b3*2*t)+3)*(768 div 6));
   y2:=Round((2*sin(b4*d)-sin(b3*2*d)+3)*(768 div 6));
   _Line(x2,y2,x,y,15);
   t:=t+0.03;
  end;
  FadeInColor;
  delay(500);
 until KeyPressed;
 ReadKey;
 _SetTextMode;
end.

