(***************************************************)
(* ColoRix Image viewer, v. 3.00                   *)
(* (C)1997-1999 Virtual Research                   *)
(***************************************************)
(* Example program for VRg SuperVGA library        *)
(*                                                 *)
(* ColoRix image file format is:                   *)
(* Signature: 'RIX3'                               *)
(* Width    : word                                 *)
(* Height   : word                                 *)
(* Magic(?) : word = $AF (for non-compressed 8bpp) *)
(* Raw bitmap data : Width*Height bytes            *) 
(***************************************************)

program RIXVIEW;
{$I-,S-,Q-,R-,V-,B-,X+,G+,N+}
uses CRT, SVGA, VGA256, XManager;


 (* Declarations *)


const Copyleft='RIXVIEW - The ColoRix image viewer, v. 3.00'+#10+#13+
                '(C) 1997-1999 Virtual Research';
      ZOOM=1;
      SCALE=0;
      BlankPal:array[0..767] of byte=
      (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
       0,0,0,0,0,0,0,0); (* Blank Palette :) *)

       KeyUpArrow=72*256;
       KeyPgUp=73*256;
       KeyLeftArrow=75*256;
       KeyRightArrow=77*256;
       KeyDownArrow=80*256;
       KeyPgDn=81*256;
       KeyCtrlPgDn=118*256;
       KeyCtrlPgUp=132*256;
       KeyF2=60*256;


procedure FONT;external;
{$L FONT.OBJ}

var FadeInF,FadeOutF,PostPalF,PosXF,PosYF,
    ZoomF,ScaleF,KeyF,GraphF,QuietF:boolean;       (* Flags *)
    FileName:string;                               (* Input file name *)
    ImageFile:file;                                (* Input file handler *)
    PicWidth,PicHeight:word;                       (* Picture dimensions *)
    Mode:integer;                                  (* Videomode number *)
    XPos,YPos:integer;                             (* Upper left corner *)
    Pal:array[0..767] of byte;                     (* Palette *)
    Descriptor:TxmmMoveStruc;                      (* XMS move descriptor *)
    Buffer:pointer;                                (* Image buffer *)
    PicSize:longint;                               (* Image Size *)
    Handle:word;                                   (* XMS buffer handle *)
    BrightestColor:byte;                           (* Color for messages *)
    DarkestColor:byte;                             (* Color for background *)
    Count:word;                                    (* Bytes read from file *)

 (* Procedures and funcs *)

procedure GetBrightestColor;
        (* Gets darkest and brightest colors from palette *)
var i,R,G,B:byte;
    Brightness,Darkness:word;
begin
 _GetColor(0,R,G,B);
 Brightness:=R+G+B;
 Darkness:=Brightness;
 BrightestColor:=0;
 DarkestColor:=0;
 for i:=1 to 255 do begin
  _GetColor(i,R,G,B);
  if (R+G+B)>Brightness then begin
   Brightness:=R+G+B;
   BrightestColor:=i;
  end;
  if (R+G+B)<Darkness then begin
   Darkness:=R+G+B;
   DarkestColor:=i;
  end;
 end;
 if DarkestColor=0 then begin
  Inc(_TransparentColor);
  Inc(vgaTransparentColor);
 end;
end;

procedure ShowHelp;
    (* Show help, then exit *)
var i:word;
const Message:array[1..15] of string[80]=
(#10+#13+Copyleft+#10+#13,
 'Usage: RIXVIEW <filename> [options]',
 'Options are:',
 '/Mn - force mode n, from 0 (320x200) through 4 (1024x768)',
 '/Z  - zoom in resolution',
 '/S  - scale to resolution',
 '/Xn - display at specified X',
 '/Yn - display at specified Y',
 '/I  - fade in',
 '/O  - fade out',
 '/P  - set palette after loading',
 '/K  - skip keypress',
 '/G  - leave display in graphics',
 '/Q  - quiet!',
 'Options must be separated by space characters.');
begin
 ClrScr;
 for i:=1 to 15 do WriteLn(Message[i]);
 Halt(0);
end;

procedure AnalyzeCmdLine;
    (* Analyzing command line *)
var Param:string;
    TmpStr:string;
    i,j:word;
    Code:integer;
begin
 TmpStr:='';
 if ParamCount=0 then ShowHelp;
 for i:=1 to ParamCount do begin
  Param:=ParamStr(i);
  if (Param[1]<>'/') and (Param[1]<>'-') then FileName:=Param
  else
   case UpCase(Param[2]) of
    'M':case Param[3] of
         '0'..'4':Val(Param[3],Mode,Code);
        else
         Mode:=-1;
        end;
    'I':FadeInF:=true;
    'O':FadeOutF:=true;
    'P':PostPalF:=true;
    'Z':ZoomF:=true;
    'S':ScaleF:=true;
    'K':KeyF:=true;
    'G':GraphF:=true;
    'Q':QuietF:=true;
    'X':begin
         PosXF:=true;
         for j:=3 to Length(Param) do TmpStr:=TmpStr+Param[j];
         Val(TmpStr,XPos,Code);
         if Code<>0 then XPos:=0;
         TmpStr:='';
        end;
    'Y':begin
         PosYF:=true;
         for j:=3 to Length(Param) do TmpStr:=TmpStr+Param[j];
         val(TmpStr,YPos,Code);
         if Code<>0 then YPos:=0;
         TmpStr:='';
        end;
    '?':ShowHelp;
   else
    ShowHelp;
   end;
  (* end if *)
 end;
end;

procedure GetFileDimensions;
    (* Gets picture dimensions from file *)
var PicMetrics:array [0..1] of word;
begin
 Seek(ImageFile,4);
 BlockRead(ImageFile,PicMetrics,4,Count);
 PicWidth:=PicMetrics[0];
 PicHeight:=PicMetrics[1];
end;

procedure ErrorMessage(Mes:string);
    (* Show error message, then exit *)
begin
 if Buffer<> nil then FreeMem(Buffer,64000);
 xmmFreeEMB(Handle);
 _SetTextMode;
 WriteLn(Copyleft,#10,#13);
 WriteLn('RIXVIEW ERROR: '+Mes);
 Halt($FF);
end;

procedure AutoMode;
    (* Detect proper videomode *)
begin
 if (PicWidth<=320) and (PicHeight<=200) then Mode:=0
 else if (PicWidth<=640) and (PicHeight<=480) then Mode:=2
      else if (PicWidth<=800) and (PicHeight<=600) then Mode:=3
           else Mode:=4;
end;

procedure LoadImage;
        (* Load image bitmap to conventional memory or XMS *)
var Steps,NLines,Tail,BufSize:word;
    XOffset:longint;
    i,j:word;
begin
 NLines:=64000 div PicWidth;
 BufSize:=NLines*PicWidth;
 Steps:=PicHeight div NLines;
 Tail:=PicHeight mod NLines;
 GetMem(Buffer,64000);
 Seek(ImageFile,778);
 if PicSize<=64000 then BlockRead(ImageFile,Buffer^,PicSize)
 else begin
  if not xmmAllocEMB((PicSize shr 10)+1,Handle) then
   ErrorMessage('Cannot allocate extended memory');
  XOffset:=0;
  with Descriptor do begin
   Length:=BufSize;
   if Odd(BufSize) then Inc(Length);
   SourceHandle:=0;
   SourceOffset:=Seg(Buffer^)*65536+Ofs(Buffer^);
   DestHandle:=Handle;
  end;
  for i:=1 to Steps do begin
   BlockRead(ImageFile,Buffer^,BufSize);
   Descriptor.DestOffset:=XOffset;
   if not xmmMoveEMB(Descriptor) then
    ErrorMessage('Cannot move data to extended memory');
   Inc(XOffset,BufSize);
  end;
  BufSize:=Tail*PicWidth;
  BlockRead(ImageFile,Buffer^,BufSize);
  if Odd(BufSize) then Inc(BufSize);
  Descriptor.Length:=BufSize;
  Descriptor.DestOffset:=XOffset;
  if not xmmMoveEMB(Descriptor) then
   ErrorMessage('Cannot move data to extended memory');
  FreeMem(Buffer,64000);Buffer:=nil;
 end;
 Close(ImageFile);
end;

procedure PutAtXY;
        (* Put bitmap to screen *)
begin
 if Buffer<>nil then
  if Mode=0 then vgaPutImage(XPos,YPos,PicWidth,PicHeight,Buffer)
   else _PutImage(XPos,YPos,PicWidth,PicHeight,Buffer)
 else
  if Mode=0 then vgaPutLargeImage(XPos,YPos,PicWidth,PicHeight,Handle)
   else _PutLargeImage(XPos,YPos,PicWidth,PicHeight,Handle);
end;

function Max(A,B:single):single;
begin
 if A>B then Max:=A else Max:=B;
end;

procedure LoadScale(Switch:byte);
    (* Fill entire screen with picture, or scale picture
       to screen resolution *)
var NewWidth,NewHeight:word;
    XFactor,YFactor,MaxFactor:single;
    BufferPtr:pointer;
    SecBufPtr:pointer;
    LineCount,RowCount:single;
    Segment1,Offset1,Segment2,Offset2:word;
    MaxDim,CurRow:word;
begin
 XFactor:=PicWidth/(_MaxX+1);
 YFactor:=PicHeight/(_MaxY+1);
 case Switch of
  ZOOM:  begin
          XPos:=0;YPos:=0;
          NewWidth:=_MaxX+1;NewHeight:=_MaxY+1;
         end;
  SCALE: begin
          MaxFactor:=Max(XFactor,YFactor);
          if MaxFactor=XFactor then begin
           XPos:=0;
           NewWidth:=_MaxX+1;
           NewHeight:=Trunc(PicHeight/XFactor);
           YFactor:=PicHeight/NewHeight;
           YPos:=(_MaxY+1-NewHeight) div 2;
          end
          else begin
           YPos:=0;
           NewHeight:=_MaxY+1;
           NewWidth:=Trunc(PicWidth/YFactor);
           XFactor:=PicWidth/NewWidth;
           XPos:=(_MaxX+1-NewWidth) div 2;
          end;
         end;
 end;
 GetMem(BufferPtr,NewWidth);
 GetMem(SecBufPtr,PicWidth);
 Segment1:=Seg(BufferPtr^);
 Offset1:=Ofs(BufferPtr^);
 Segment2:=Seg(SecBufPtr^);
 Offset2:=Ofs(SecBufPtr^);
 Seek(ImageFile,778);
 LineCount:=0;
 while LineCount<(PicHeight-1) do begin
  Seek(ImageFile,778+Round(LineCount)*PicWidth);
  BlockRead(ImageFile,SecBufPtr^,PicWidth);
  RowCount:=0;CurRow:=0;
  while RowCount<PicWidth do begin
   Mem[Segment1:Offset1+CurRow]:=Mem[Segment2:Offset2+Trunc(RowCount)];
   RowCount:=RowCount+XFactor;
   Inc(CurRow);
  end;
  if mode=0 then vgaPutImage(XPos,YPos,NewWidth,1,BufferPtr)
   else _PutImage(XPos,YPos,NewWidth,1,BufferPtr);
  Inc(YPos);
  LineCount:=LineCount+YFactor;
 end;
 FreeMem(BufferPtr,NewWidth);
 FreeMem(SecBufPtr,PicWidth);
 Close(ImageFile);
end;

function Number2FileName(n:longint):string;
var s:string;
begin
 s:='';
 Str(n,s);
 while Length(s)<8 do s:='0'+s;
 s:=s+'.PCX';
 Number2FileName:=s;
end;

function FileExists(FileName:string):boolean;
var f:file;
    t:word;
begin
 t:=FileMode;
 FileMode:=0;
 Assign(f,FileName);
 Reset(f);
 FileMode:=t;
 t:=IOResult;
 if t=0 then Close(f);
 FileExists:=(t=0);
end;

function WaitKey:word;assembler;
asm
 xor ax,ax
 int $16
 cmp al,0
 je @@exit
 and ax,$00FF
@@exit:
end;

procedure CheckKey;
    (* If F2 pressed, save current screen;
       if cursor keys - move picture;
       if other key - just exit *)
var C:word;
    Xr,Yr:string;
    Buf:pointer;
const WFlag:boolean=false;
const FileN:longint=1;
begin
 GetMem(Buf,16*88);
 repeat
  C:=WaitKey;
  case C of
   KeyF2: begin
    while FileExists(Number2FileName(FileN)) and (FileN<99999999) do Inc(FileN);
    if FileN<99999999 then begin
     if Mode<>0 then _SavePCX(Number2FileName(FileN),0,0,_MaxX,_MaxY)
      else vgaSavePCX(Number2FileName(FileN),0,0,319,199);
     Inc(FileN);
    end
    else
     Sound(440);Delay(500);NoSound;
   end;
   KeyRightArrow: begin
    if (not ScaleF) and (not ZoomF) and (PicWidth>_MaxX+1) then begin
     Dec(XPos,_MaxX div 10);
     if XPos+PicWidth<_MaxX then XPos:=_MaxX-PicWidth+1;
     WFlag:=false;
     PutAtXY;
    end;
   end;
   KeyLeftArrow: begin
    if (not ScaleF) and (not ZoomF) and (PicWidth>_MaxX+1) then begin
     Inc(XPos,_MaxX div 10);
     if XPos>0 then XPos:=0;
     WFlag:=false;
     PutAtXY;
    end;
   end;
   KeyDownArrow: begin
    if (not ScaleF) and (not ZoomF) and (PicHeight>_MaxY+1) then begin
     Dec(YPos,_MaxY div 10);
     if YPos+PicHeight<_MaxY then YPos:=_MaxY-PicHeight+1;
     WFlag:=false;
     PutAtXY;
    end;
   end;
   KeyUpArrow: begin
    if (not ScaleF) and (not ZoomF) and (PicHeight>_MaxY+1) then begin
     Inc(YPos,_MaxY div 10);
     if YPos>0 then YPos:=0;
     WFlag:=false;
     PutAtXY;
    end;
   end;
   KeyPgUp: begin
    if (not ScaleF) and (not ZoomF) and (PicHeight>_MaxY+1) then begin
     YPos:=0;
     WFlag:=false;
     PutAtXY;
    end;
   end;
   KeyPgDn: begin
    if (not ScaleF) and (not ZoomF) and (PicHeight>_MaxY+1) then begin
     YPos:=_MaxY-PicHeight+1;
     WFlag:=false;
     PutAtXY;
    end;
   end;
   KeyCtrlPgDn: begin
    if (not ScaleF) and (not ZoomF) and (PicWidth>_MaxX+1) then begin
     XPos:=_MaxX-PicWidth+1;
     WFlag:=false;
     PutAtXY;
    end;
   end;
   KeyCtrlPgUp: begin
    if (not ScaleF) and (not ZoomF) and (PicWidth>_MaxX+1) then begin
     XPos:=0;
     WFlag:=false;
     PutAtXY;
    end;
   end;
   Ord('i'),Ord('I'): begin
    if not WFlag then begin
     if Mode=0 then vgaGetImage(0,0,87,15,Buf)
               else _GetImage(0,0,87,15,Buf);
     Str(PicWidth,Xr);
     Str(PicHeight,Yr);
     if Mode=0 then begin
      vgaBox(0,0,(Length(Xr)+Length(Yr)+1)*8-1,15,DarkestColor,DarkestColor);
      vgaWriteStr(0,0,Xr+'x'+Yr,BrightestColor);
     end else begin
      _Box(0,0,(Length(Xr)+Length(Yr)+1)*8-1,15,DarkestColor,DarkestColor);
      _WriteStr(0,0,Xr+'x'+Yr,BrightestColor);
     end;
    end
    else begin
     if Mode=0 then vgaPutImage(0,0,88,16,Buf)
               else _PutImage(0,0,88,16,Buf);
    end;
    WFlag:=not WFlag;
   end;
  else break
  end;
 until false;
end;

function UpCaseStr(s:string):string;
var i:word;
begin
 for i:=1 to Length(s) do s[i]:=UpCase(s[i]);
 UpCaseStr:=s;
end;

procedure FastLoad;
var p:pointer;
    i,BlockSize,NBlocks,Remainder:word;
begin
 Seek(ImageFile,778);
 BlockSize:=(32768 div (_MaxX+1))*(_MaxX+1);
 GetMem(p,BlockSize);
 NBlocks:=PicSize div BlockSize;
 Remainder:=PicSize mod BlockSize;
 for i:=1 to NBlocks do begin
  BlockRead(ImageFile,p^,BlockSize,Count);
  _PutImage(0,(i-1)*(BlockSize div _MaxX),_MaxX+1,(BlockSize div _MaxX),p);
 end;
 BlockRead(ImageFile,p^,Remainder,Count);
 _PutImage(0,NBlocks*(BlockSize div _MaxX),_MaxX+1,(Remainder div _MaxX),p);
 FreeMem(p,BlockSize);
end;

 (* Main *)

begin


 (* Let's check some fatal cases *)

 if Test8086<2 then ErrorMessage('386 or better CPU required');
 if MaxAvail<150000 then ErrorMessage('Insufficient memory');
 if not _VESAPresent then ErrorMessage('VESA compliant BIOS not detected');
 if not xmmPresent then ErrorMessage('Extended Memory Manager not installed');


 (* Now will set default values *)

 FileMode:=0;
 FadeInF:=false;FadeOutF:=false;PostPalF:=false;PosXF:=false;PosYF:=false;
 ZoomF:=false;ScaleF:=false;KeyF:=false;GraphF:=false;QuietF:=false;
 FileName:='';Buffer:=nil;
 XPos:=0; YPos:=0; Mode:=-1;


 (* Now will set new values for parameters and open input file *)

 AnalyzeCmdLine;
 if FileName='' then ShowHelp;
 if not QuietF then WriteLn(Copyleft);
 if FileName[Length(FileName)]='.' then FileName:=FileName+'SCF';
 if Pos('.',FileName)=0 then FileName:=FileName+'.SCF';
 FileName:=UpCaseStr(FileName);
 Assign(ImageFile,FileName);
 Reset(ImageFile,1);
 if IOResult<>0 then ErrorMessage('Cannot open '+FileName);
 BlockRead(ImageFile,PicSize,4,Count);
 GetFileDimensions;
 if (PicSize<>$33584952) or
    (FileSize(ImageFile)<>longint(PicWidth)*PicHeight+778) then
  ErrorMessage('Input file corrupted or not a ColoRix image');
 Seek(ImageFile,10);
 BlockRead(ImageFile,Pal,768,Count); Seek(ImageFile,0);
 if Mode=-1 then AutoMode;
 case Mode of
  1: Mode:=_640x400;
  2: Mode:=_640x480;
  3: Mode:=_800x600;
  4: Mode:=_1024x768;
 end;
 PicSize:=longint(PicWidth)*PicHeight;

 (* Now will initialize graphics *)

 if Mode<>0 then _SetMode(Mode) else begin
  _MaxX:=319;_MaxY:=199;vgaSetMode; end;
 if Mode<>0 then _SetFont(@FONT) else vgaSetFont(@FONT);
 if (not PosXF) and (PicWidth<_MaxX) then
  XPos:=(_MaxX+1-PicWidth) div 2;
 if (not PosYF) and (PicHeight<_MaxY) then
  YPos:=(_MaxY+1-PicHeight) div 2;
 if XPos>_MaxX then XPos:=0;
 if YPos>_MaxY then YPos:=0;
 _SetPalette(BlankPal);
 if (not PostPalF) and (not FadeInF) then _SetPalette(Pal);


 (* Now will load image *)

 repeat
  if ScaleF and ((PicWidth>(_MaxX+1)) or (PicHeight>(_MaxY+1))) then begin
   LoadScale(SCALE);
   Break;
  end;
  if ZoomF and ((PicWidth<>(_MaxX+1)) or (PicHeight<>(_MaxY+1))) then begin
   LoadScale(ZOOM);
   Break;
  end;
  if (PicWidth=320) and (PicHeight<=200) and (Mode=0) and (YPos=0) then begin
   Seek(ImageFile,778);
   BlockRead(ImageFile,Ptr($A000,0)^,PicSize,Count);
   Break;
  end;
  if (PicWidth=(_MaxX+1)) and (PicHeight<=(_MaxY+1)) and (YPos=0) then begin
   FastLoad;
   Break;
  end;
  LoadImage;
  PutAtXY;
  Break;
 until true;


 (* Now will close graphics and exit *)

 if FadeInF then _FadeIn(Pal,70);
 if PostPalF then _SetPalette(Pal);
 GetBrightestColor;
 if not KeyF then CheckKey;
 if FadeOutF then _FadeOut(Pal,70);
 if Buffer<>nil then FreeMem(Buffer,64000);
 xmmFreeEMB(Handle);
 if not GraphF then _SetTextMode;
end.
