(********************************)
(* 32-bit Move and FillChar     *)
(* for Borland Pascal 7         *)
(* (C) 1998 by Asp / VR group   *)
(* Unit version : 1.0           *)
(* System : DOS, DPMI16         *)      
(********************************)

{.$D+,Y+,L+}
{$S-,Q-,R-,V-,X+,G+}
unit Mem32;

interface
 procedure Move(var Source,Destination; Count:word);
 procedure FillChar(var Destination; Count:word; Value:byte);

implementation

procedure Move(var Source,Destination; Count:word);assembler;
asm
 push ds
 lds si,Source
 les di,Destination
 mov cx,Count
 mov bx,cx
 shr cx,2
 db $66; rep movsw
 mov cx,bx
 and cx,3
 rep movsb
 pop ds
end;

procedure FillChar(var Destination; Count:word; Value:byte);assembler;
asm
 les di,Destination
 mov al,Value
 mov ah,al
 mov bx,ax
 db $66; shl ax,16
 mov ax,bx
 mov cx,Count
 mov bx,cx
 shr cx,2
 db $66; rep stosw
 mov cx,bx
 and cx,3
 rep stosb
end;

end.

 
